typedef union {
	char* str;
	ID* id;
	id_list* id_l;
	init_class ic;
	Val* val;
	RE_Matcher* re;
	Expr* expr;
	CallExpr* call_expr;
	EventExpr* event_expr;
	Stmt* stmt;
	ListExpr* list;
	BroType* type;
	RecordType* record;
	FuncType* func_type;
	TypeList* type_l;
	TypeDecl* type_decl;
	type_decl_list* type_decl_l;
	Case* c_case;
	case_list* case_l;
	Attr* attr;
	attr_list* attr_l;
	attr_tag attrtag;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#define	TOK_ADD	257
#define	TOK_ADD_TO	258
#define	TOK_ADDR	259
#define	TOK_ALARM	260
#define	TOK_ANY	261
#define	TOK_ATENDIF	262
#define	TOK_ATELSE	263
#define	TOK_ATIF	264
#define	TOK_ATIFDEF	265
#define	TOK_ATIFNDEF	266
#define	TOK_BOOL	267
#define	TOK_BREAK	268
#define	TOK_CASE	269
#define	TOK_CONST	270
#define	TOK_CONSTANT	271
#define	TOK_COPY	272
#define	TOK_COUNT	273
#define	TOK_COUNTER	274
#define	TOK_DEFAULT	275
#define	TOK_DELETE	276
#define	TOK_DOUBLE	277
#define	TOK_ELSE	278
#define	TOK_ENUM	279
#define	TOK_EVENT	280
#define	TOK_EXPORT	281
#define	TOK_FILE	282
#define	TOK_FOR	283
#define	TOK_FUNCTION	284
#define	TOK_GLOBAL	285
#define	TOK_GLOBAL_ATTR	286
#define	TOK_ID	287
#define	TOK_IF	288
#define	TOK_INT	289
#define	TOK_INTERVAL	290
#define	TOK_LIST	291
#define	TOK_LOCAL	292
#define	TOK_MODULE	293
#define	TOK_MATCH	294
#define	TOK_NET	295
#define	TOK_NEXT	296
#define	TOK_OF	297
#define	TOK_PATTERN	298
#define	TOK_PATTERN_TEXT	299
#define	TOK_PORT	300
#define	TOK_PRINT	301
#define	TOK_RECORD	302
#define	TOK_REDEF	303
#define	TOK_REMOVE_FROM	304
#define	TOK_RETURN	305
#define	TOK_SCHEDULE	306
#define	TOK_SET	307
#define	TOK_STRING	308
#define	TOK_SUBNET	309
#define	TOK_SWITCH	310
#define	TOK_TABLE	311
#define	TOK_THIS	312
#define	TOK_TIME	313
#define	TOK_TIMEOUT	314
#define	TOK_TIMER	315
#define	TOK_TYPE	316
#define	TOK_UNION	317
#define	TOK_VECTOR	318
#define	TOK_WHEN	319
#define	TOK_ATTR_ADD_FUNC	320
#define	TOK_ATTR_ATTR	321
#define	TOK_ATTR_ENCRYPT	322
#define	TOK_ATTR_DEFAULT	323
#define	TOK_ATTR_OPTIONAL	324
#define	TOK_ATTR_REDEF	325
#define	TOK_ATTR_ROTATE_INTERVAL	326
#define	TOK_ATTR_ROTATE_SIZE	327
#define	TOK_ATTR_DEL_FUNC	328
#define	TOK_ATTR_EXPIRE_FUNC	329
#define	TOK_ATTR_EXPIRE_CREATE	330
#define	TOK_ATTR_EXPIRE_READ	331
#define	TOK_ATTR_EXPIRE_WRITE	332
#define	TOK_ATTR_PERSISTENT	333
#define	TOK_ATTR_SYNCHRONIZED	334
#define	TOK_ATTR_DISABLE_PRINT_HOOK	335
#define	TOK_ATTR_RAW_OUTPUT	336
#define	TOK_ATTR_MERGEABLE	337
#define	TOK_ATTR_PRIORITY	338
#define	TOK_ATTR_GROUP	339
#define	TOK_DEBUG	340
#define	TOK_USING	341
#define	TOK_OR	342
#define	TOK_AND	343
#define	TOK_LE	344
#define	TOK_GE	345
#define	TOK_EQ	346
#define	TOK_NE	347
#define	TOK_IN	348
#define	TOK_NOT_IN	349
#define	TOK_INCR	350
#define	TOK_DECR	351
#define	TOK_HAS_FIELD	352
#define	TOK_HAS_ATTR	353


extern YYSTYPE yylval;
