// This file is automatically generated from ./dns_tcp.pac.

#ifndef __dns_tcp_pac_h
#define __dns_tcp_pac_h

#include <vector>

#include "binpac.h"


#include "dns_pac.h"	// for DNS_Conn


#include "binpac_bro.h"

namespace binpac {

namespace DNS_on_TCP {
class ContextDNS_on_TCP;
class DNS_TCP_PDU;
class DNS_TCP_Conn;
class DNS_TCP_Flow;
} // namespace DNS_on_TCP

double network_time();
namespace DNS_on_TCP {

class ContextDNS_on_TCP
{
public:
	ContextDNS_on_TCP(DNS_TCP_Conn * connection, DNS_TCP_Flow * flow, FlowBuffer * flow_buffer);
	~ContextDNS_on_TCP();
	
	// Member access functions
	DNS_TCP_Conn * connection() const { return connection_; }
	DNS_TCP_Flow * flow() const { return flow_; }
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	
protected:
	DNS_TCP_Conn * connection_;
	DNS_TCP_Flow * flow_;
	FlowBuffer * flow_buffer_;
};


class DNS_TCP_PDU
{
public:
	DNS_TCP_PDU(bool is_orig);
	~DNS_TCP_PDU();
	int initial_buffer_length() const { return 2; }
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextDNS_on_TCP * t_context);
	
	// Member access functions
	uint16 msglen() const { return msglen_; }
	bytestring const & msg() const { return msg_; }
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	bool deliver() const { return deliver_; }
	
protected:
	uint16 msglen_;
	bytestring msg_;
	bool is_orig_;
	int byteorder_;
	bool deliver_;
	int buffering_state_;
};


class DNS_TCP_Conn : public binpac::ConnectionAnalyzer
{
public:
	DNS_TCP_Conn(BroAnalyzer const & bro_analyzer);
	~DNS_TCP_Conn();
	
	// Member access functions
	DNS_TCP_Flow * upflow() const { return upflow_; }
	DNS_TCP_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool deliver_dns_message(bool is_orig, const_bytestring const & msg);
	
protected:
	
	// Additional members

		DNS::DNS_Conn *abstract_dns_connection_;
	
	DNS_TCP_Flow * upflow_;
	DNS_TCP_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class DNS_TCP_Flow : public binpac::FlowAnalyzer
{
public:
	DNS_TCP_Flow(DNS_TCP_Conn * connection, bool is_orig);
	~DNS_TCP_Flow();
	
	// Member access functions
	DNS_TCP_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	DNS_TCP_PDU * dataunit_;
	ContextDNS_on_TCP * context_;
	FlowBuffer * flow_buffer_;
	DNS_TCP_Conn * connection_;
	bool is_orig_;
};

} // namespace DNS_on_TCP
}  // namespace binpac
#endif /* __dns_tcp_pac_h */
