// This file is automatically generated from ./http.pac.

#include "../src/http_pac.h"

namespace binpac {






namespace HTTP {
ContextHTTP::ContextHTTP(HTTP_Conn * connection, HTTP_Flow * flow, FlowBuffer * flow_buffer)
	{
	connection_ = connection;
	flow_ = flow;
	flow_buffer_ = flow_buffer;
	}

ContextHTTP::~ContextHTTP()
	{
	}

RegExMatcher HTTP_TOKEN_re_001("[^()<>@,;:\\\"/\\[\\]?={} \\t]+");

RegExMatcher HTTP_WS_re_002("[ \\t]*");

RegExMatcher HTTP_URI_re_003("[[:alnum:][:punct:]]+");

HTTP_PDU::HTTP_PDU(bool is_orig)
	{
	val_case_index_ = -1;
	request_ = 0;
	reply_ = 0;
	is_orig_ = is_orig;
	}

HTTP_PDU::~HTTP_PDU()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "request"
			{
			delete request_;
			request_ = 0;
			}
			break;
		case 0:
			// Clean up "reply"
			{
			delete reply_;
			reply_ = 0;
			}
			break;
		}
	}

bool HTTP_PDU::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	val_case_index_ = is_orig();
	switch ( val_case_index() )
		{
		case 1:
			// Parse "request"
			{
			if ( ! request_ )
				{
				request_ = new HTTP_Request();
				}
			bool t_request_parsing_complete;
			t_request_parsing_complete = false;
			t_request_parsing_complete = request_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_request_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_request_parsing_complete;
			}
			break;
		case 0:
			// Parse "reply"
			{
			if ( ! reply_ )
				{
				reply_ = new HTTP_Reply();
				}
			bool t_reply_parsing_complete;
			t_reply_parsing_complete = false;
			t_reply_parsing_complete = reply_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_reply_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_reply_parsing_complete;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("HTTP_PDU", val_case_index());
			break;
		}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		process_message_ = t_context->flow()->http_message_done(this);
		}
	return t_val_parsing_complete;
	}

HTTP_Request::HTTP_Request()
	{
	request_ = 0;
	buffering_state_ = 0;
	msg_ = 0;
	parsing_state_ = 0;
	}

HTTP_Request::~HTTP_Request()
	{
	delete request_;
	request_ = 0;
	delete msg_;
	msg_ = 0;
	}

bool HTTP_Request::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	switch ( parsing_state_ ) {
	case 0:
		// Parse "request"
		if ( ! request_ )
			{
			request_ = new HTTP_RequestLine();
			}
		if ( buffering_state_ == 0 )
			{
			t_flow_buffer->NewLine();
			buffering_state_ = 1;
			}
		parsing_state_ = 1;
	case 1:
		{
		bool t_request_parsing_complete;
		t_request_parsing_complete = false;
		while ( ! t_request_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			t_request_parsing_complete = request_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_request_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			buffering_state_ = 0;
			}
		if ( ! (t_request_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "msg"
		if ( ! msg_ )
			{
			msg_ = new HTTP_Message(BODY_MAYBE);
			}
		parsing_state_ = 2;
	case 2:
		{
		bool t_msg_parsing_complete;
		t_msg_parsing_complete = false;
		t_msg_parsing_complete = msg_->ParseBuffer(t_flow_buffer, t_context);
		if ( t_msg_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_msg_parsing_complete) )
			goto need_more_data;
		}
		
		
		t_val_parsing_complete = true;
	}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

ExpectBody expect_reply_body(int reply_status)
	{

	// TODO: check if the request is "HEAD"
	if ( (reply_status >= 100 && reply_status < 200) ||
	     reply_status == 204 || reply_status == 304 )
		return BODY_NOT_EXPECTED;
	return BODY_EXPECTED;
	
	}

HTTP_Reply::HTTP_Reply()
	{
	reply_ = 0;
	buffering_state_ = 0;
	msg_ = 0;
	parsing_state_ = 0;
	}

HTTP_Reply::~HTTP_Reply()
	{
	delete reply_;
	reply_ = 0;
	delete msg_;
	msg_ = 0;
	}

bool HTTP_Reply::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	switch ( parsing_state_ ) {
	case 0:
		// Parse "reply"
		if ( ! reply_ )
			{
			reply_ = new HTTP_ReplyLine();
			}
		if ( buffering_state_ == 0 )
			{
			t_flow_buffer->NewLine();
			buffering_state_ = 1;
			}
		parsing_state_ = 1;
	case 1:
		{
		bool t_reply_parsing_complete;
		t_reply_parsing_complete = false;
		while ( ! t_reply_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			t_reply_parsing_complete = reply_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_reply_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			buffering_state_ = 0;
			}
		if ( ! (t_reply_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "msg"
		if ( ! msg_ )
			{
			msg_ = new HTTP_Message(expect_reply_body(reply()->status()->stat_num()));
			}
		parsing_state_ = 2;
	case 2:
		{
		bool t_msg_parsing_complete;
		t_msg_parsing_complete = false;
		t_msg_parsing_complete = msg_->ParseBuffer(t_flow_buffer, t_context);
		if ( t_msg_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_msg_parsing_complete) )
			goto need_more_data;
		}
		
		
		t_val_parsing_complete = true;
	}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

HTTP_RequestLine::HTTP_RequestLine()
	{
	version_ = 0;
	buffering_state_ = 0;
	}

HTTP_RequestLine::~HTTP_RequestLine()
	{
	method_.free();
	uri_.free();
	delete version_;
	version_ = 0;
	}

bool HTTP_RequestLine::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	// Parse "method"
	int t_method_string_length;
	t_method_string_length = 
		HTTP_TOKEN_re_001.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_method_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:53", "[^()<>@,;:\\\"/\\[\\]?={} \\t]+", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_method__size;
	t_method__size = t_method_string_length;
	// check for negative sizes
	if ( t_method_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:53", t_method_string_length);
	method_.init(t_begin_of_data, t_method_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_method = t_begin_of_data + (t_method__size);
	BINPAC_ASSERT(t_dataptr_after_method <= t_end_of_data);
	// Parse "anonymous_field_004"
	bytestring anonymous_field_004_;
	int t_anonymous_field_004_string_length;
	t_anonymous_field_004_string_length = 
		HTTP_WS_re_002.MatchPrefix(
			t_dataptr_after_method,
			t_end_of_data - t_dataptr_after_method);
	if ( t_anonymous_field_004_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:54", "[ \\t]*", string((const char *) (t_dataptr_after_method), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_004__size;
	t_anonymous_field_004__size = t_anonymous_field_004_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_004_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_004 = t_dataptr_after_method + (t_anonymous_field_004__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_004 <= t_end_of_data);
	// Parse "uri"
	int t_uri_string_length;
	t_uri_string_length = 
		HTTP_URI_re_003.MatchPrefix(
			t_dataptr_after_anonymous_field_004,
			t_end_of_data - t_dataptr_after_anonymous_field_004);
	if ( t_uri_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:55", "[[:alnum:][:punct:]]+", string((const char *) (t_dataptr_after_anonymous_field_004), (const char *) t_end_of_data).c_str());
		}
	int t_uri__size;
	t_uri__size = t_uri_string_length;
	// check for negative sizes
	if ( t_uri_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:55", t_uri_string_length);
	uri_.init(t_dataptr_after_anonymous_field_004, t_uri_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_uri = t_dataptr_after_anonymous_field_004 + (t_uri__size);
	BINPAC_ASSERT(t_dataptr_after_uri <= t_end_of_data);
	// Parse "anonymous_field_005"
	bytestring anonymous_field_005_;
	int t_anonymous_field_005_string_length;
	t_anonymous_field_005_string_length = 
		HTTP_WS_re_002.MatchPrefix(
			t_dataptr_after_uri,
			t_end_of_data - t_dataptr_after_uri);
	if ( t_anonymous_field_005_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:56", "[ \\t]*", string((const char *) (t_dataptr_after_uri), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_005__size;
	t_anonymous_field_005__size = t_anonymous_field_005_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_005_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_005 = t_dataptr_after_uri + (t_anonymous_field_005__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_005 <= t_end_of_data);
	// Parse "version"
	version_ = new HTTP_Version();
	int t_version__size;
	t_version__size = version_->Parse(t_dataptr_after_anonymous_field_005, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	t_val_parsing_complete = true;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		process_request_ = t_context->flow()->http_request(method(), uri(), version());
		}
	buffering_state_ = 0;
	return t_val_parsing_complete;
	}

HTTP_ReplyLine::HTTP_ReplyLine()
	{
	version_ = 0;
	status_ = 0;
	buffering_state_ = 0;
	}

HTTP_ReplyLine::~HTTP_ReplyLine()
	{
	delete version_;
	version_ = 0;
	delete status_;
	status_ = 0;
	reason_.free();
	}

bool HTTP_ReplyLine::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	// Parse "version"
	version_ = new HTTP_Version();
	int t_version__size;
	t_version__size = version_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_version = t_begin_of_data + (t_version__size);
	BINPAC_ASSERT(t_dataptr_after_version <= t_end_of_data);
	// Parse "anonymous_field_006"
	bytestring anonymous_field_006_;
	int t_anonymous_field_006_string_length;
	t_anonymous_field_006_string_length = 
		HTTP_WS_re_002.MatchPrefix(
			t_dataptr_after_version,
			t_end_of_data - t_dataptr_after_version);
	if ( t_anonymous_field_006_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:62", "[ \\t]*", string((const char *) (t_dataptr_after_version), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_006__size;
	t_anonymous_field_006__size = t_anonymous_field_006_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_006_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_006 = t_dataptr_after_version + (t_anonymous_field_006__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_006 <= t_end_of_data);
	// Parse "status"
	status_ = new HTTP_Status();
	int t_status__size;
	t_status__size = status_->Parse(t_dataptr_after_anonymous_field_006, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_status = t_dataptr_after_anonymous_field_006 + (t_status__size);
	BINPAC_ASSERT(t_dataptr_after_status <= t_end_of_data);
	// Parse "anonymous_field_007"
	bytestring anonymous_field_007_;
	int t_anonymous_field_007_string_length;
	t_anonymous_field_007_string_length = 
		HTTP_WS_re_002.MatchPrefix(
			t_dataptr_after_status,
			t_end_of_data - t_dataptr_after_status);
	if ( t_anonymous_field_007_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:64", "[ \\t]*", string((const char *) (t_dataptr_after_status), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_007__size;
	t_anonymous_field_007__size = t_anonymous_field_007_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_007_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_007 = t_dataptr_after_status + (t_anonymous_field_007__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_007 <= t_end_of_data);
	// Parse "reason"
	int t_reason_string_length;
	t_reason_string_length = (t_end_of_data) - (t_dataptr_after_anonymous_field_007);
	int t_reason__size;
	t_reason__size = t_reason_string_length;
	// check for negative sizes
	if ( t_reason_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:65", t_reason_string_length);
	reason_.init(t_dataptr_after_anonymous_field_007, t_reason_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	t_val_parsing_complete = true;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		process_reply_ = t_context->flow()->http_reply(version(), status()->stat_num(), reason());
		}
	buffering_state_ = 0;
	return t_val_parsing_complete;
	}

RegExMatcher HTTP_Status_re_008("[0-9]{3}");

HTTP_Status::HTTP_Status()
	{
	}

HTTP_Status::~HTTP_Status()
	{
	stat_str_.free();
	}

int HTTP_Status::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "stat_str"
	int t_stat_str_string_length;
	t_stat_str_string_length = 
		HTTP_Status_re_008.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_stat_str_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:69", "[0-9]{3}", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_stat_str__size;
	t_stat_str__size = t_stat_str_string_length;
	// check for negative sizes
	if ( t_stat_str_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:69", t_stat_str_string_length);
	stat_str_.init(t_begin_of_data, t_stat_str_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_HTTP_Status__size;
	const_byteptr const t_dataptr_after_stat_str = t_begin_of_data + (t_stat_str__size);
	BINPAC_ASSERT(t_dataptr_after_stat_str <= t_end_of_data);
	t_HTTP_Status__size = t_dataptr_after_stat_str - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	stat_num_ = bytestring_to_int(stat_str(), 10);
	BINPAC_ASSERT(t_begin_of_data + (t_HTTP_Status__size) <= t_end_of_data);
	return t_HTTP_Status__size;
	}

RegExMatcher HTTP_Version_re_010("[0-9]+\\.[0-9]+");

HTTP_Version::HTTP_Version()
	{
	}

HTTP_Version::~HTTP_Version()
	{
	vers_str_.free();
	}

int HTTP_Version::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "HTTP_Version:anonymous_field_009"
	if ( t_begin_of_data + (5) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("HTTP_Version:anonymous_field_009",
			(0) + (5), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "anonymous_field_009"
	bytestring anonymous_field_009_;
	if ( memcmp(t_begin_of_data, "HTTP/", 5) != 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:75", "HTTP/", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_009_.free();
	
	// Parse "vers_str"
	int t_vers_str_string_length;
	t_vers_str_string_length = 
		HTTP_Version_re_010.MatchPrefix(
			(t_begin_of_data + 5),
			t_end_of_data - (t_begin_of_data + 5));
	if ( t_vers_str_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:76", "[0-9]+\\.[0-9]+", string((const char *) ((t_begin_of_data + 5)), (const char *) t_end_of_data).c_str());
		}
	int t_vers_str__size;
	t_vers_str__size = t_vers_str_string_length;
	// check for negative sizes
	if ( t_vers_str_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:76", t_vers_str_string_length);
	vers_str_.init((t_begin_of_data + 5), t_vers_str_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_HTTP_Version__size;
	const_byteptr const t_dataptr_after_vers_str = (t_begin_of_data + 5) + (t_vers_str__size);
	BINPAC_ASSERT(t_dataptr_after_vers_str <= t_end_of_data);
	t_HTTP_Version__size = t_dataptr_after_vers_str - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	vers_num_ = bytestring_to_double(vers_str());
	BINPAC_ASSERT(t_begin_of_data + (t_HTTP_Version__size) <= t_end_of_data);
	return t_HTTP_Version__size;
	}

HTTP_Headers::HTTP_Headers()
	{
	val_ = 0;
	val__elem_ = 0;
	buffering_state_ = 0;
	val__elem__it_ = -1;
	}

HTTP_Headers::~HTTP_Headers()
	{
	delete val__elem_;
	val__elem_ = 0;
	if ( val() )
		{
		for ( int i = 0; i < (int) val()->size(); ++i )
			{
			HTTP_Header * val__elem_ = (*val_)[i];
			delete val__elem_;
			val__elem_ = 0;
			}
		}
	delete val_;
	}

bool HTTP_Headers::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	if ( val__elem__it_ < 0 )
		{
		// Initialize only once
		val__elem__it_ = 0;
		val_ = new vector<HTTP_Header *>;
		}
	for (; /* forever */; ++val__elem__it_)
		{
		if ( ! val__elem_ )
			{
			val__elem_ = new HTTP_Header();
			}
		if ( buffering_state_ == 0 )
			{
			t_flow_buffer->NewLine();
			buffering_state_ = 1;
			}
		bool t_val__elem_parsing_complete;
		t_val__elem_parsing_complete = false;
		while ( ! t_val__elem_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			const_bytestring t_val__elem_input(t_begin_of_data, t_end_of_data);
			// Check &until( ( @$input->length@() == ((int) 0) ) )
			if (  ( t_val__elem_input.length() == 0 )  )
				{
				t_val_parsing_complete = true;
				delete val__elem_;
				val__elem_ = 0;
				goto end_of_val;
				}
			t_val__elem_parsing_complete = val__elem_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_val__elem_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			buffering_state_ = 0;
			}
		if ( ! t_val__elem_parsing_complete )
			goto need_more_data;
		val_->push_back(val__elem_);
		val__elem_ = 0;
		}
end_of_val: ;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		process_end_of_headers_ = t_context->flow()->http_end_of_headers(this);
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

HTTP_Message::HTTP_Message(ExpectBody expect_body)
	{
	headers_ = 0;
	body_or_not_case_index_ = -1;
	body_ = 0;
	expect_body_ = expect_body;
	parsing_state_ = 0;
	}

HTTP_Message::~HTTP_Message()
	{
	delete headers_;
	headers_ = 0;
	switch ( body_or_not_case_index() )
		{
		case 1:
			// Clean up "none"
			{
			}
			break;
		default:
			// Clean up "body"
			{
			delete body_;
			body_ = 0;
			}
			break;
		}
	}

bool HTTP_Message::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	switch ( parsing_state_ ) {
	case 0:
		// Parse "headers"
		if ( ! headers_ )
			{
			headers_ = new HTTP_Headers();
			}
		parsing_state_ = 1;
	case 1:
		{
		bool t_headers_parsing_complete;
		t_headers_parsing_complete = false;
		t_headers_parsing_complete = headers_->ParseBuffer(t_flow_buffer, t_context);
		if ( t_headers_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_headers_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "body_or_not"
		parsing_state_ = 2;
	case 2:
		{
		bool t_body_or_not_parsing_complete;
		t_body_or_not_parsing_complete = false;
		body_or_not_case_index_ = expect_body();
		switch ( body_or_not_case_index() )
			{
			case 1:
				// Parse "none"
				{
				bool t_none_parsing_complete;
				t_none_parsing_complete = false;
				t_none_parsing_complete = true;
				t_body_or_not_parsing_complete = t_none_parsing_complete;
				}
				break;
			default:
				// Parse "body"
				{
				if ( ! body_ )
					{
					body_ = new HTTP_Body(expect_body());
					}
				bool t_body_parsing_complete;
				t_body_parsing_complete = false;
				t_body_parsing_complete = body_->ParseBuffer(t_flow_buffer, t_context);
				if ( t_body_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				t_body_or_not_parsing_complete = t_body_parsing_complete;
				}
				break;
			}
		if ( t_body_or_not_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_body_or_not_parsing_complete) )
			goto need_more_data;
		}
		
		
		t_val_parsing_complete = true;
	}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

RegExMatcher HTTP_HEADER_NAME_re_011("|([^: \\t]+:)");

HTTP_Header::HTTP_Header()
	{
	buffering_state_ = 0;
	}

HTTP_Header::~HTTP_Header()
	{
	}

bool HTTP_Header::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	// Parse "name"
	int t_name_string_length;
	t_name_string_length = 
		HTTP_HEADER_NAME_re_011.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_name_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:96", "|([^: \\t]+:)", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_name__size;
	t_name__size = t_name_string_length;
	// check for negative sizes
	if ( t_name_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:96", t_name_string_length);
	name_.init(t_begin_of_data, t_name_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_name = t_begin_of_data + (t_name__size);
	BINPAC_ASSERT(t_dataptr_after_name <= t_end_of_data);
	// Parse "anonymous_field_012"
	bytestring anonymous_field_012_;
	int t_anonymous_field_012_string_length;
	t_anonymous_field_012_string_length = 
		HTTP_WS_re_002.MatchPrefix(
			t_dataptr_after_name,
			t_end_of_data - t_dataptr_after_name);
	if ( t_anonymous_field_012_string_length < 0 )
		{
		throw ExceptionStringMismatch("./http-protocol.pac:97", "[ \\t]*", string((const char *) (t_dataptr_after_name), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_012__size;
	t_anonymous_field_012__size = t_anonymous_field_012_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_012_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_012 = t_dataptr_after_name + (t_anonymous_field_012__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_012 <= t_end_of_data);
	// Parse "value"
	int t_value_string_length;
	t_value_string_length = (t_end_of_data) - (t_dataptr_after_anonymous_field_012);
	int t_value__size;
	t_value__size = t_value_string_length;
	// check for negative sizes
	if ( t_value_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:98", t_value_string_length);
	value_.init(t_dataptr_after_anonymous_field_012, t_value_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	t_val_parsing_complete = true;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		process_header_ = t_context->flow()->http_header(name_, value_);
		}
	buffering_state_ = 0;
	return t_val_parsing_complete;
	}

MIME_Line::MIME_Line()
	{
	buffering_state_ = 0;
	}

MIME_Line::~MIME_Line()
	{
	}

bool MIME_Line::ParseBuffer(flow_buffer_t t_flow_buffer)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	// Parse "line"
	int t_line_string_length;
	t_line_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_line__size;
	t_line__size = t_line_string_length;
	// check for negative sizes
	if ( t_line_string_length < 0 )
	throw ExceptionInvalidStringLength("./http-protocol.pac:102", t_line_string_length);
	line_.init(t_begin_of_data, t_line_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	t_val_parsing_complete = true;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	buffering_state_ = 0;
	return t_val_parsing_complete;
	}

MIME_Lines::MIME_Lines()
	{
	val_ = 0;
	val__elem_ = 0;
	buffering_state_ = 0;
	val__elem__it_ = -1;
	}

MIME_Lines::~MIME_Lines()
	{
	delete val__elem_;
	val__elem_ = 0;
	if ( val() )
		{
		for ( int i = 0; i < (int) val()->size(); ++i )
			{
			MIME_Line * val__elem_ = (*val_)[i];
			delete val__elem_;
			val__elem_ = 0;
			}
		}
	delete val_;
	}

bool MIME_Lines::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	if ( val__elem__it_ < 0 )
		{
		// Initialize only once
		val__elem__it_ = 0;
		val_ = new vector<MIME_Line *>;
		}
	for (; /* forever */; ++val__elem__it_)
		{
		if ( ! val__elem_ )
			{
			val__elem_ = new MIME_Line();
			}
		if ( buffering_state_ == 0 )
			{
			t_flow_buffer->NewLine();
			buffering_state_ = 1;
			}
		bool t_val__elem_parsing_complete;
		t_val__elem_parsing_complete = false;
		while ( ! t_val__elem_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			const_bytestring t_val__elem_input(t_begin_of_data, t_end_of_data);
			// Check &until( ( @@$context->flow@->is_end_of_multipart@($input) ) )
			if (  ( t_context->flow()->is_end_of_multipart(t_val__elem_input) )  )
				{
				t_val_parsing_complete = true;
				delete val__elem_;
				val__elem_ = 0;
				goto end_of_val;
				}
			t_val__elem_parsing_complete = val__elem_->ParseBuffer(t_flow_buffer);
			if ( t_val__elem_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			buffering_state_ = 0;
			}
		if ( ! t_val__elem_parsing_complete )
			goto need_more_data;
		val_->push_back(val__elem_);
		val__elem_ = 0;
		}
end_of_val: ;
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

HTTP_Body::HTTP_Body(ExpectBody expect_body)
	{
	val_case_index_ = -1;
	buffering_state_ = 0;
	chunks_ = 0;
	multipart_ = 0;
	unknown_ = 0;
	expect_body_ = expect_body;
	}

HTTP_Body::~HTTP_Body()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "body"
			{
			}
			break;
		case 2:
			// Clean up "chunks"
			{
			delete chunks_;
			chunks_ = 0;
			}
			break;
		case 3:
			// Clean up "multipart"
			{
			delete multipart_;
			multipart_ = 0;
			}
			break;
		default:
			// Clean up "unknown"
			{
			delete unknown_;
			unknown_ = 0;
			}
			break;
		}
	}

bool HTTP_Body::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	val_case_index_ = t_context->flow()->delivery_mode();
	switch ( val_case_index() )
		{
		case 1:
			// Parse "body"
			{
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(0, true);
				buffering_state_ = 1;
				}
			bool t_body_parsing_complete;
			t_body_parsing_complete = false;
			while ( ! t_body_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				switch ( buffering_state_ )
					{
					case 0:
						if ( buffering_state_ == 0 )
							{
							t_flow_buffer->NewFrame(0, true);
							buffering_state_ = 1;
							}
						buffering_state_ = 1;
						break;
					case 1:
						{
						buffering_state_ = 2;
						t_flow_buffer->GrowFrame(t_context->flow()->content_length());
						}
						break;
					case 2:
						BINPAC_ASSERT(t_flow_buffer->ready());
						if ( t_flow_buffer->ready() )
							{
							int t_body_string_length;
							t_body_string_length = t_context->flow()->content_length();
							// check for negative sizes
							if ( t_body_string_length < 0 )
							throw ExceptionInvalidStringLength("./http-protocol.pac:113", t_body_string_length);
							body_.init(t_begin_of_data, t_body_string_length);
							t_body_parsing_complete = true;
							if ( t_body_parsing_complete )
								{
								// Evaluate 'let' and 'withinput' fields
								}
							BINPAC_ASSERT(t_body_parsing_complete);
							buffering_state_ = 0;
							}
						break;
					default:
						BINPAC_ASSERT(buffering_state_ <= 2);
						break;
					}
				}
			t_val_parsing_complete = t_body_parsing_complete;
			}
			break;
		case 2:
			// Parse "chunks"
			{
			if ( ! chunks_ )
				{
				chunks_ = new HTTP_Chunks();
				}
			bool t_chunks_parsing_complete;
			t_chunks_parsing_complete = false;
			t_chunks_parsing_complete = chunks_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_chunks_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_chunks_parsing_complete;
			}
			break;
		case 3:
			// Parse "multipart"
			{
			if ( ! multipart_ )
				{
				multipart_ = new MIME_Lines();
				}
			bool t_multipart_parsing_complete;
			t_multipart_parsing_complete = false;
			t_multipart_parsing_complete = multipart_->ParseBuffer(t_flow_buffer, t_context);
			if ( t_multipart_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_multipart_parsing_complete;
			}
			break;
		default:
			// Parse "unknown"
			{
			if ( ! unknown_ )
				{
				unknown_ = new HTTP_UnknownBody(expect_body());
				}
			bool t_unknown_parsing_complete;
			t_unknown_parsing_complete = false;
			t_unknown_parsing_complete = unknown_->ParseBuffer(t_flow_buffer);
			if ( t_unknown_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_unknown_parsing_complete;
			}
			break;
		}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	return t_val_parsing_complete;
	}

HTTP_UnknownBody::HTTP_UnknownBody(ExpectBody expect_body)
	{
	val_case_index_ = -1;
	buffering_state_ = 0;
	expect_body_ = expect_body;
	}

HTTP_UnknownBody::~HTTP_UnknownBody()
	{
	switch ( val_case_index() )
		{
		case 2:
		case 1:
			// Clean up "maybenot"
			{
			}
			break;
		case 0:
			// Clean up "rest"
			{
			}
			break;
		}
	}

bool HTTP_UnknownBody::ParseBuffer(flow_buffer_t t_flow_buffer)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	val_case_index_ = expect_body();
	switch ( val_case_index() )
		{
		case 2:
		case 1:
			// Parse "maybenot"
			{
			bool t_maybenot_parsing_complete;
			t_maybenot_parsing_complete = false;
			t_maybenot_parsing_complete = true;
			t_val_parsing_complete = t_maybenot_parsing_complete;
			}
			break;
		case 0:
			// Parse "rest"
			{
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(-1, true);
				buffering_state_ = 1;
				}
			bool t_rest_parsing_complete;
			t_rest_parsing_complete = false;
			while ( ! t_rest_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				BINPAC_ASSERT(t_flow_buffer->eof());
				int t_rest_string_length;
				t_rest_string_length = (t_end_of_data) - (t_begin_of_data);
				// check for negative sizes
				if ( t_rest_string_length < 0 )
				throw ExceptionInvalidStringLength("./http-protocol.pac:125", t_rest_string_length);
				rest_.init(t_begin_of_data, t_rest_string_length);
				t_rest_parsing_complete = true;
				if ( t_rest_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_rest_parsing_complete;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("HTTP_UnknownBody", val_case_index());
			break;
		}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	return t_val_parsing_complete;
	}

HTTP_Chunks::HTTP_Chunks()
	{
	chunks_ = 0;
	chunks__elem_ = 0;
	chunks__elem__it_ = -1;
	headers_ = 0;
	parsing_state_ = 0;
	}

HTTP_Chunks::~HTTP_Chunks()
	{
	delete chunks__elem_;
	chunks__elem_ = 0;
	if ( chunks() )
		{
		for ( int i = 0; i < (int) chunks()->size(); ++i )
			{
			HTTP_Chunk * chunks__elem_ = (*chunks_)[i];
			delete chunks__elem_;
			chunks__elem_ = 0;
			}
		}
	delete chunks_;
	delete headers_;
	headers_ = 0;
	}

bool HTTP_Chunks::ParseBuffer(flow_buffer_t t_flow_buffer, ContextHTTP * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	switch ( parsing_state_ ) {
	case 0:
		// Parse "chunks"
		if ( ! chunks_ )
			{
			}
		parsing_state_ = 1;
	case 1:
		{
		bool t_chunks_parsing_complete;
		t_chunks_parsing_complete = false;
		if ( chunks__elem__it_ < 0 )
			{
			// Initialize only once
			chunks__elem__it_ = 0;
			chunks_ = new vector<HTTP_Chunk *>;
			}
		for (; /* forever */; ++chunks__elem__it_)
			{
			if ( ! chunks__elem_ )
				{
				chunks__elem_ = new HTTP_Chunk();
				}
			bool t_chunks__elem_parsing_complete;
			t_chunks__elem_parsing_complete = false;
			t_chunks__elem_parsing_complete = chunks__elem_->ParseBuffer(t_flow_buffer);
			if ( t_chunks__elem_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			if ( ! t_chunks__elem_parsing_complete )
				goto need_more_data;
			chunks_->push_back(chunks__elem_);
			// Check &until( ( @$element->chunk_length@ == ((int) 0) ) )
			if (  ( chunks__elem_->chunk_length() == 0 )  )
				{
				t_chunks_parsing_complete = true;
				chunks__elem_ = 0;
				goto end_of_chunks;
				}
			chunks__elem_ = 0;
			}
	end_of_chunks: ;
		if ( t_chunks_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_chunks_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "headers"
		if ( ! headers_ )
			{
			headers_ = new HTTP_Headers();
			}
		parsing_state_ = 2;
	case 2:
		{
		bool t_headers_parsing_complete;
		t_headers_parsing_complete = false;
		t_headers_parsing_complete = headers_->ParseBuffer(t_flow_buffer, t_context);
		if ( t_headers_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_headers_parsing_complete) )
			goto need_more_data;
		}
		
		
		t_val_parsing_complete = true;
	}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

HTTP_Chunk::HTTP_Chunk()
	{
	buffering_state_ = 0;
	opt_crlf_case_index_ = -1;
	parsing_state_ = 0;
	}

HTTP_Chunk::~HTTP_Chunk()
	{
	length_line_.free();
	switch ( opt_crlf_case_index() )
		{
		case 0:
			// Clean up "none"
			{
			}
			break;
		default:
			// Clean up "crlf"
			{
			crlf_.free();
			}
			break;
		}
	}

bool HTTP_Chunk::ParseBuffer(flow_buffer_t t_flow_buffer)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	switch ( parsing_state_ ) {
	case 0:
		// Parse "length_line"
		if ( buffering_state_ == 0 )
			{
			t_flow_buffer->NewLine();
			buffering_state_ = 1;
			}
		parsing_state_ = 1;
	case 1:
		{
		bool t_length_line_parsing_complete;
		t_length_line_parsing_complete = false;
		while ( ! t_length_line_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			int t_length_line_string_length;
			t_length_line_string_length = (t_end_of_data) - (t_begin_of_data);
			// check for negative sizes
			if ( t_length_line_string_length < 0 )
			throw ExceptionInvalidStringLength("./http-protocol.pac:134", t_length_line_string_length);
			length_line_.init(t_begin_of_data, t_length_line_string_length);
			t_length_line_parsing_complete = true;
			if ( t_length_line_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			buffering_state_ = 0;
			}
		if ( ! (t_length_line_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "data"
		t_flow_buffer->NewFrame(-1, true);
		parsing_state_ = 2;
	case 2:
		{
		bool t_data_parsing_complete;
		t_data_parsing_complete = false;
		while ( ! t_data_parsing_complete && t_flow_buffer->ready() )
			{
			const_byteptr t_begin_of_data = t_flow_buffer->begin();
			const_byteptr t_end_of_data = t_flow_buffer->end();
			switch ( buffering_state_ )
				{
				case 0:
					t_flow_buffer->NewFrame(-1, true);
					buffering_state_ = 1;
					break;
				case 1:
					{
					buffering_state_ = 2;
					chunk_length_ = bytestring_to_int(length_line(), 16);
					t_flow_buffer->GrowFrame(chunk_length());
					}
					break;
				case 2:
					BINPAC_ASSERT(t_flow_buffer->ready());
					if ( t_flow_buffer->ready() )
						{
						int t_data_string_length;
						t_data_string_length = chunk_length();
						// check for negative sizes
						if ( t_data_string_length < 0 )
						throw ExceptionInvalidStringLength("./http-protocol.pac:135", t_data_string_length);
						data_.init(t_begin_of_data, t_data_string_length);
						t_data_parsing_complete = true;
						if ( t_data_parsing_complete )
							{
							// Evaluate 'let' and 'withinput' fields
							}
						BINPAC_ASSERT(t_data_parsing_complete);
						buffering_state_ = 0;
						}
					break;
				default:
					BINPAC_ASSERT(buffering_state_ <= 2);
					break;
				}
			}
		if ( ! (t_data_parsing_complete) )
			goto need_more_data;
		}
		
		// Parse "opt_crlf"
		parsing_state_ = 3;
	case 3:
		{
		bool t_opt_crlf_parsing_complete;
		t_opt_crlf_parsing_complete = false;
		opt_crlf_case_index_ = chunk_length();
		switch ( opt_crlf_case_index() )
			{
			case 0:
				// Parse "none"
				{
				bool t_none_parsing_complete;
				t_none_parsing_complete = false;
				t_none_parsing_complete = true;
				t_opt_crlf_parsing_complete = t_none_parsing_complete;
				}
				break;
			default:
				// Parse "crlf"
				{
				if ( buffering_state_ == 0 )
					{
					t_flow_buffer->NewLine();
					buffering_state_ = 1;
					}
				bool t_crlf_parsing_complete;
				t_crlf_parsing_complete = false;
				while ( ! t_crlf_parsing_complete && t_flow_buffer->ready() )
					{
					const_byteptr t_begin_of_data = t_flow_buffer->begin();
					const_byteptr t_end_of_data = t_flow_buffer->end();
					int t_crlf_string_length;
					t_crlf_string_length = (t_end_of_data) - (t_begin_of_data);
					// check for negative sizes
					if ( t_crlf_string_length < 0 )
					throw ExceptionInvalidStringLength("./http-protocol.pac:138", t_crlf_string_length);
					crlf_.init(t_begin_of_data, t_crlf_string_length);
					t_crlf_parsing_complete = true;
					if ( t_crlf_parsing_complete )
						{
						// Evaluate 'let' and 'withinput' fields
						}
					buffering_state_ = 0;
					}
				t_opt_crlf_parsing_complete = t_crlf_parsing_complete;
				}
				break;
			}
		if ( t_opt_crlf_parsing_complete )
			{
			// Evaluate 'let' and 'withinput' fields
			}
		if ( ! (t_opt_crlf_parsing_complete) )
			goto need_more_data;
		}
		
		
		t_val_parsing_complete = true;
	}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	BINPAC_ASSERT(t_val_parsing_complete);
	return t_val_parsing_complete;
	
need_more_data:
	BINPAC_ASSERT(!(t_val_parsing_complete));
	return false;
	}

bytestring to_upper(const_bytestring const & s)
	{

	char* buf = new char[s.length() + 1];
	const char* sp = (const char*) s.begin();

	for ( int i = 0; i < s.length(); ++i )
		if ( islower(sp[i]) )
			buf[i] = toupper(sp[i]);
		else
			buf[i] = sp[i];

	buf[s.length()] = '\0';

	return bytestring((uint8*) buf, s.length());
	
	}

HTTP_Conn::HTTP_Conn(BroAnalyzer const & bro_analyzer)
	{
	upflow_ = new HTTP_Flow(this, true);
	downflow_ = new HTTP_Flow(this, false);
	bro_analyzer_ = bro_analyzer;
	}

HTTP_Conn::~HTTP_Conn()
	{
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void HTTP_Conn::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void HTTP_Conn::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void HTTP_Conn::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();
	}

HTTP_Flow::HTTP_Flow(HTTP_Conn * connection, bool is_orig)
	{
	flow_buffer_ = 0;
	connection_ = connection;
	is_orig_ = is_orig;

		content_length_ = 0;
		delivery_mode_ = UNKNOWN_DELIVERY_MODE;

		msg_start_time_ = 0;
		msg_begin_seq_ = 0;
		msg_header_end_seq_ = -1;

		build_headers_ = (::http_all_headers != 0);
	
	dataunit_ = 0;
	context_ = 0;
	flow_buffer_ = new FlowBuffer();
	}

HTTP_Flow::~HTTP_Flow()
	{
	delete dataunit_;
	dataunit_ = 0;
	delete context_;
	context_ = 0;

		end_of_multipart_.free();
	
	delete flow_buffer_;
	flow_buffer_ = 0;
	}

void HTTP_Flow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		flow_buffer_->NewData(t_begin_of_data, t_end_of_data);
		while ( flow_buffer_->data_available() && 
			( !flow_buffer_->have_pending_request() || flow_buffer_->ready() ) )
			{
			if ( ! dataunit_ )
				{
				BINPAC_ASSERT(!context_);
				dataunit_ = new HTTP_PDU(is_orig());
				context_ = new ContextHTTP(connection(), this, flow_buffer_);
				}
			bool t_dataunit_parsing_complete;
			t_dataunit_parsing_complete = false;
			t_dataunit_parsing_complete = dataunit_->ParseBuffer(flow_buffer_, context_);
			if ( t_dataunit_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			if ( t_dataunit_parsing_complete )
				{
				// Clean up the flow unit after parsing
				delete dataunit_;
				dataunit_ = 0;
				delete context_;
				context_ = 0;
				}
			else
				{
				// Resume upon next input segment
				BINPAC_ASSERT(!flow_buffer_->ready());
				break;
				}
			}
		}
	catch ( Exception const &e )
		{
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;

		end_of_multipart_.free();
	
		flow_buffer_->DiscardData();
		throw e;
		}
	}

void HTTP_Flow::NewGap(int gap_length)
	{
	flow_buffer_->NewGap(gap_length);
	}
void HTTP_Flow::FlowEOF()
	{
	flow_buffer_->set_eof();
	NewData(0, 0);
	}
int HTTP_Flow::content_length()
	{

		return content_length_;
		
	}

DeliveryMode HTTP_Flow::delivery_mode()
	{

		return delivery_mode_;
		
	}

const_bytestring HTTP_Flow::end_of_multipart()
	{

		return end_of_multipart_;
		
	}

bool HTTP_Flow::http_request(const_bytestring const & method, const_bytestring const & uri, HTTP_Version * vers)
	{

		if ( ::http_request )
			{
			bytestring unescaped_uri = unescape_uri(uri);
			bro_event_http_request(connection()->bro_analyzer(),
				connection()->bro_analyzer()->Conn(),
				bytestring_to_val(method),
				bytestring_to_val(uri),
				bytestring_to_val(unescaped_uri),
				bytestring_to_val(vers->vers_str()));
			unescaped_uri.free();
			}

		http_message_begin();

		return true;
		
	}

bool HTTP_Flow::http_reply(HTTP_Version * vers, int code, const_bytestring const & reason)
	{

		if ( ::http_reply )
			{
			bro_event_http_reply(connection()->bro_analyzer(),
				connection()->bro_analyzer()->Conn(),
				bytestring_to_val(vers->vers_str()), code,
				bytestring_to_val(reason));
			}

		http_message_begin();

		return true;
		
	}

BroVal HTTP_Flow::build_http_header_val(const_bytestring const & name, const_bytestring const & value)
	{

		RecordVal* header_record = new RecordVal(mime_header_rec);

		StringVal* name_val = 0;
		if ( name.length() > 0 )
			{
			// Make it all uppercase.
			name_val = new StringVal(name.length(),
						(const char*) name.begin());
			name_val->ToUpper();
			}
		else
			name_val = new StringVal("");

		header_record->Assign(0, name_val);
		header_record->Assign(1, bytestring_to_val(value));

		return header_record;
		
	}

bytestring HTTP_Flow::extract_boundary(const_bytestring const & value)
	{

		const char* boundary_prefix = "boundary=";
		const char* boundary_begin = strcasestr(
						(const char*) value.begin(),
						boundary_prefix);

		if ( ! boundary_begin )
			return bytestring();

		boundary_begin += 9;

		const char* boundary_end = strcasestr(boundary_begin, ";");
		if ( ! boundary_end )
			boundary_end = (const char*) value.end();

		return bytestring((const uint8*) boundary_begin,
					(const uint8*) boundary_end);
		
	}

bool HTTP_Flow::is_end_of_multipart(const_bytestring const & line)
	{

		if ( line.length() < 4 + end_of_multipart_.length() )
			return false;

		int len = end_of_multipart_.length();

		// line =?= "--" end_of_multipart_ "--"
		return ( line[0] == '-' && line[1] == '-' &&
			 line[len + 2] == '-' && line[len + 3] == '-' &&
			 strncmp((const char*) line.begin() + 2,
				(const char*) end_of_multipart_.begin(),
				len) == 0 );
		
	}

bool HTTP_Flow::http_header(const_bytestring const & name_colon, const_bytestring const & value)
	{

		const_bytestring name(
			name_colon.begin(),
			name_colon.length() > 0 ?
				name_colon.end() - 1 :
				name_colon.end());

		if ( bytestring_casecmp(name, "CONTENT-LENGTH") == 0 )
			{
			content_length_ = bytestring_to_int(value, 10);
			delivery_mode_ = CONTENT_LENGTH;
			}

		else if ( bytestring_casecmp(name, "TRANSFER-ENCODING") == 0 )
			{
			if ( bytestring_caseprefix(value, "CHUNKED") )
				delivery_mode_ = CHUNKED;
			}

		else if ( bytestring_casecmp(name, "CONTENT-TYPE") == 0 )
			{
			if ( bytestring_caseprefix(value, "MULTIPART") )
				{
				end_of_multipart_.free();
				end_of_multipart_ = extract_boundary(value);
				if ( end_of_multipart_.length() > 0 )
					delivery_mode_ = MULTIPART;
				}
			}

		if ( ::http_header )
			{
			bro_event_http_header(connection()->bro_analyzer(),
				connection()->bro_analyzer()->Conn(),
				is_orig(),
				bytestring_to_val(name)->ToUpper(),
				bytestring_to_val(value));
			}

		if ( build_headers_ )
			headers_.push_back(build_http_header_val(name, value));

		return true;
		
	}

BroVal HTTP_Flow::build_http_headers_val()
	{

		TableVal* t = new TableVal(mime_header_list);

		for ( unsigned int i = 0; i < headers_.size(); ++i )
			{ // index starting from 1
			Val* index = new Val(i + 1, TYPE_COUNT);
			t->Assign(index, headers_[i]);
			Unref(index);
			}

		return t;
		
	}

void HTTP_Flow::gen_http_all_headers()
	{

		if ( ::http_all_headers )
			{
			bro_event_http_all_headers(connection()->bro_analyzer(),
						connection()->bro_analyzer()->Conn(),
						is_orig(),
						build_http_headers_val());
			}

		headers_.clear();
		
	}

bool HTTP_Flow::http_end_of_headers(HTTP_Headers * headers)
	{

		if ( delivery_mode_ != CHUNKED && build_headers_ )
			gen_http_all_headers();

		// Check if this is the first set of headers
		// (i.e. not headers after chunks).
		if ( msg_header_end_seq_ == -1 )
			msg_header_end_seq_ = flow_buffer_->data_seq();

		return true;
		
	}

void HTTP_Flow::http_message_begin()
	{

		msg_start_time_ = network_time();
		if ( ::http_begin_entity )
			{
			bro_event_http_begin_entity(connection()->bro_analyzer(),
							connection()->bro_analyzer()->Conn(), is_orig());
			}
		
	}

BroVal HTTP_Flow::build_http_message_stat()
	{

		int msg_header_length = msg_header_end_seq_ - msg_begin_seq_;
		int msg_body_length =
			flow_buffer_->data_seq() - msg_header_end_seq_;

		bool msg_interrupted = false;

		RecordVal* stat = new RecordVal(http_message_stat);
		int field = 0;
		stat->Assign(field++, new Val(msg_start_time_, TYPE_TIME));
		stat->Assign(field++, new Val(msg_interrupted, TYPE_BOOL));
		stat->Assign(field++, new StringVal(""));
		stat->Assign(field++, new Val(msg_body_length, TYPE_COUNT));
		stat->Assign(field++, new Val(0, TYPE_COUNT));
		stat->Assign(field++, new Val(msg_header_length, TYPE_COUNT));

		return stat;
		
	}

bool HTTP_Flow::http_message_done(HTTP_PDU * pdu)
	{

		if ( ! headers_.empty() )
			gen_http_all_headers();

		if ( ::http_end_entity )
			{
			bro_event_http_end_entity(connection()->bro_analyzer(),
							connection()->bro_analyzer()->Conn(), is_orig());
			}

		if ( ::http_message_done )
			{
			bro_event_http_message_done(connection()->bro_analyzer(),
					connection()->bro_analyzer()->Conn(),
					is_orig(), build_http_message_stat());
			}

		end_of_multipart_.free();

		// Initialize for next message.
		msg_begin_seq_ = flow_buffer_->data_seq();
		msg_header_end_seq_ = -1;

		return true;
		
	}

bytestring HTTP_Flow::unescape_uri(const_bytestring const & uri)
	{

		const u_char* line = uri.begin();
		const u_char* line_end = uri.end();
		BroAnalyzer a = connection()->bro_analyzer();

		// ### Copied from HTTP.cc
		byte_vec decoded_URI = new u_char[line_end - line + 1];
		byte_vec URI_p = decoded_URI;

		// An 'unescaped_special_char' here means a character that
		// *should* be escaped, but isn't in the URI.  A control
		// character that appears directly in the URI would be an
		// example.  The RFC implies that if we do not unescape the
		// URI that we see in the trace, every character should be a
		// printable one -- either reserved or unreserved (or '%').
		//
		// Counting the number of unescaped characters and generating
		// a weird event on URI's with unescaped characters (which
		// are rare) will let us locate strange-looking URI's in the
		// trace -- those URI's are often interesting.

		int unescaped_special_char = 0;

		while ( line < line_end )
			{
			if ( *line == '%' )
				{
				++line;

				if ( line == line_end )
					{
					// How to deal with % at end of line?
					// *URI_p++ = '%';
					if ( a )
						a->Weird("illegal_%_at_end_of_URI");
					break;
					}

				else if ( *line == '%' )
					{
					// Double '%' might be either due to
					// software bug, or, more likely, an
					// evasion (e.g., used by Nimda).
					// *URI_p++ = '%';
					if ( a )
						a->Weird("double_%_in_URI");
					--line;	// ignore the first '%'
					}

				else if ( isxdigit(line[0]) && isxdigit(line[1]) )
					{
					*URI_p++ = (decode_hex(line[0]) << 4) +
						   decode_hex(line[1]);
					++line; // place line at last hex digit
					}

				else
					{
					if ( a )
						a->Weird("unescaped_%_in_URI");
					*URI_p++ = '%';	// put back initial '%'
					// Take char. without interpretation..
					*URI_p++ = *line;
					}
				}

			else
				{
				if ( ! is_reserved_URI_char(*line) &&
				     ! is_unreserved_URI_char(*line) )
					// Count these up as a way to compress
					// the corresponding Weird event to a
					// single instance.
					++unescaped_special_char;
				*URI_p++ = *line;
				}

			++line;
			}

		URI_p[0] = 0;

		if ( unescaped_special_char && a )
			a->Weird("unescaped_special_URI_char");

		return bytestring(decoded_URI, URI_p - decoded_URI);
		
	}

} // namespace HTTP
}  // namespace binpac
