// This file is automatically generated from ./rpc.pac.

#include "../src/rpc_pac.h"

namespace binpac {






namespace SunRPC {
ContextSunRPC::ContextSunRPC(RPC_Conn * connection, RPC_Flow * flow)
	{
	connection_ = connection;
	flow_ = flow;
	}

ContextSunRPC::~ContextSunRPC()
	{
	}

EnumRPCService RPC_Service(uint32 prog, uint32 vers)
	{
	int t_t_var_001;
	switch ( prog )
		{
		case 100000:
			t_t_var_001 = RPC_SERVICE_PORTMAP;
			break;
		default:
			t_t_var_001 = RPC_SERVICE_UNKNOWN;
			break;
		}
	return static_cast<EnumRPCService>(t_t_var_001);
	}



inline EnumRPCService RPC_Service(const RPC_Call* call)
	{
	// If it's an unpaired response, we ignore it for now and
	// complain later in the analyzer.
	return call ? call->service() : RPC_SERVICE_UNKNOWN;
	}

RPC_Message::RPC_Message()
	{
	xid_ = 0;
	msg_type_ = 0;
	msg_body_case_index_ = -1;
	call_ = 0;
	reply_ = 0;
	byteorder_ = bigendian;
	}

RPC_Message::~RPC_Message()
	{
	switch ( msg_body_case_index() )
		{
		case 0:
			// Clean up "call"
			{
			delete call_;
			call_ = 0;
			}
			break;
		case 1:
			// Clean up "reply"
			{
			delete reply_;
			reply_ = 0;
			}
			break;
		}
	}

int RPC_Message::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context)
	{
	sourcedata_ = const_bytestring(t_begin_of_data, t_end_of_data);
	// Checking out-of-bound for "RPC_Message:msg_type"
	if ( (t_begin_of_data + 4) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_Message:msg_type",
			(4) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "xid"
	xid_ = FixByteOrder(byteorder(), *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "msg_type"
	msg_type_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 4))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "msg_body"
	length_ = sourcedata().length();
	int t_msg_body__size;
	msg_body_case_index_ = msg_type();
	switch ( msg_body_case_index() )
		{
		case 0:
			// Parse "call"
			{
			call_ = new RPC_Call(this);
			int t_call__size;
			t_call__size = call_->Parse((t_begin_of_data + 8), t_end_of_data, t_context, byteorder());
			// Evaluate 'let' and 'withinput' fields
			t_msg_body__size = t_call__size;
			}
			break;
		case 1:
			// Parse "reply"
			{
			reply_ = new RPC_Reply(this);
			int t_reply__size;
			t_reply__size = reply_->Parse((t_begin_of_data + 8), t_end_of_data, t_context, byteorder());
			// Evaluate 'let' and 'withinput' fields
			t_msg_body__size = t_reply__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("RPC_Message", msg_body_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_Message__size;
	const_byteptr const t_dataptr_after_msg_body = (t_begin_of_data + 8) + (t_msg_body__size);
	BINPAC_ASSERT(t_dataptr_after_msg_body <= t_end_of_data);
	t_RPC_Message__size = t_dataptr_after_msg_body - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	sourcedata_.set_end(t_begin_of_data + t_RPC_Message__size);
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_Message__size) <= t_end_of_data);
	return t_RPC_Message__size;
	}

RPC_Call::RPC_Call(RPC_Message * msg)
	{
	rpcvers_ = 0;
	prog_ = 0;
	vers_ = 0;
	proc_ = 0;
	cred_ = 0;
	verf_ = 0;
	params_ = 0;
	msg_ = msg;
	}

RPC_Call::~RPC_Call()
	{
	delete cred_;
	cred_ = 0;
	delete verf_;
	verf_ = 0;
	delete params_;
	params_ = 0;
	msg_source_data_.free();
	}

int RPC_Call::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_Call:proc"
	if ( (t_begin_of_data + 12) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_Call:proc",
			(12) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "rpcvers"
	rpcvers_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "prog"
	prog_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 4))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "vers"
	vers_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 8))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "proc"
	proc_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 12))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "cred"
	cred_ = new RPC_OpaqueAuth();
	int t_cred__size;
	t_cred__size = cred_->Parse((t_begin_of_data + 16), t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_cred = (t_begin_of_data + 16) + (t_cred__size);
	BINPAC_ASSERT(t_dataptr_after_cred <= t_end_of_data);
	// Parse "verf"
	verf_ = new RPC_OpaqueAuth();
	int t_verf__size;
	t_verf__size = verf_->Parse(t_dataptr_after_cred, t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_verf = t_dataptr_after_cred + (t_verf__size);
	BINPAC_ASSERT(t_dataptr_after_verf <= t_end_of_data);
	// Parse "params"
	params_ = new RPC_Params(this);
	service_ = RPC_Service(prog(), vers());
	int t_params__size;
	t_params__size = params_->Parse(t_dataptr_after_verf, t_end_of_data, t_context, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_Call__size;
	const_byteptr const t_dataptr_after_params = t_dataptr_after_verf + (t_params__size);
	BINPAC_ASSERT(t_dataptr_after_params <= t_end_of_data);
	t_RPC_Call__size = t_dataptr_after_params - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	msg_source_data_ = msg()->sourcedata();
	newcall_ = t_context->connection()->NewCall(msg()->xid(), this);
	start_time_ = network_time();
	call_val_ = RPC_BuildCallVal(this);
	action_call_ = t_context->flow()->ProcessCall(this);
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_Call__size) <= t_end_of_data);
	return t_RPC_Call__size;
	}

RPC_Reply::RPC_Reply(RPC_Message * msg)
	{
	stat_ = 0;
	reply_case_index_ = -1;
	areply_ = 0;
	rreply_ = 0;
	msg_ = msg;
	call_ = 0;
	}

RPC_Reply::~RPC_Reply()
	{
	switch ( reply_case_index() )
		{
		case 0:
			// Clean up "areply"
			{
			delete areply_;
			areply_ = 0;
			}
			break;
		case 1:
			// Clean up "rreply"
			{
			delete rreply_;
			rreply_ = 0;
			}
			break;
		}
	delete call_;
	call_ = 0;
	}

int RPC_Reply::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_Reply:stat"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_Reply:stat",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "stat"
	stat_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "reply"
	call_ = t_context->connection()->FindCall(msg()->xid());
	int t_reply__size;
	reply_case_index_ = stat();
	switch ( reply_case_index() )
		{
		case 0:
			// Parse "areply"
			{
			areply_ = new RPC_AcceptedReply(call());
			int t_areply__size;
			t_areply__size = areply_->Parse((t_begin_of_data + 4), t_end_of_data, t_context, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_reply__size = t_areply__size;
			}
			break;
		case 1:
			// Parse "rreply"
			{
			rreply_ = new RPC_RejectedReply(call());
			int t_rreply__size;
			t_rreply__size = rreply_->Parse((t_begin_of_data + 4), t_end_of_data, t_context, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_reply__size = t_rreply__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("RPC_Reply", reply_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_Reply__size;
	const_byteptr const t_dataptr_after_reply = (t_begin_of_data + 4) + (t_reply__size);
	BINPAC_ASSERT(t_dataptr_after_reply <= t_end_of_data);
	t_RPC_Reply__size = t_dataptr_after_reply - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	success_ =  ( stat() == MSG_ACCEPTED && areply()->stat() == SUCCESS ) ;
	status_ = RPC_Status(this);
	action_reply_ = t_context->flow()->ProcessReply(this);
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_Reply__size) <= t_end_of_data);
	return t_RPC_Reply__size;
	}

RPC_AcceptedReply::RPC_AcceptedReply(RPC_Call * call)
	{
	verf_ = 0;
	stat_ = 0;
	data_case_index_ = -1;
	results_ = 0;
	mismatch_ = 0;
	call_ = call;
	}

RPC_AcceptedReply::~RPC_AcceptedReply()
	{
	delete verf_;
	verf_ = 0;
	switch ( data_case_index() )
		{
		case 0:
			// Clean up "results"
			{
			delete results_;
			results_ = 0;
			}
			break;
		case 2:
			// Clean up "mismatch"
			{
			delete mismatch_;
			mismatch_ = 0;
			}
			break;
		default:
			// Clean up "other"
			{
			}
			break;
		}
	}

int RPC_AcceptedReply::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	// Parse "verf"
	verf_ = new RPC_OpaqueAuth();
	int t_verf__size;
	t_verf__size = verf_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_verf = t_begin_of_data + (t_verf__size);
	BINPAC_ASSERT(t_dataptr_after_verf <= t_end_of_data);
	// Checking out-of-bound for "RPC_AcceptedReply:stat"
	if ( t_dataptr_after_verf + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_AcceptedReply:stat",
			((t_dataptr_after_verf - t_begin_of_data)) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "stat"
	stat_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_dataptr_after_verf)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "data"
	int t_data__size;
	data_case_index_ = stat();
	switch ( data_case_index() )
		{
		case 0:
			// Parse "results"
			{
			results_ = new RPC_Results(call());
			int t_results__size;
			t_results__size = results_->Parse((t_dataptr_after_verf + 4), t_end_of_data, t_context, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_data__size = t_results__size;
			}
			break;
		case 2:
			// Parse "mismatch"
			{
			mismatch_ = new RPC_MismatchInfo();
			mismatch_->Parse((t_dataptr_after_verf + 4), t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_data__size = 8;
			}
			break;
		default:
			// Parse "other"
			{
			// Evaluate 'let' and 'withinput' fields
			t_data__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_AcceptedReply__size;
	const_byteptr const t_dataptr_after_data = (t_dataptr_after_verf + 4) + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_RPC_AcceptedReply__size = t_dataptr_after_data - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_AcceptedReply__size) <= t_end_of_data);
	return t_RPC_AcceptedReply__size;
	}

RPC_RejectedReply::RPC_RejectedReply(RPC_Call * call)
	{
	stat_ = 0;
	data_case_index_ = -1;
	mismatch_ = 0;
	auth_stat_ = 0;
	call_ = call;
	}

RPC_RejectedReply::~RPC_RejectedReply()
	{
	switch ( data_case_index() )
		{
		case 0:
			// Clean up "mismatch"
			{
			delete mismatch_;
			mismatch_ = 0;
			}
			break;
		case 1:
			// Clean up "auth_stat"
			{
			}
			break;
		}
	}

int RPC_RejectedReply::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_RejectedReply:stat"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_RejectedReply:stat",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "stat"
	stat_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "data"
	int t_data__size;
	data_case_index_ = stat();
	switch ( data_case_index() )
		{
		case 0:
			// Parse "mismatch"
			{
			mismatch_ = new RPC_MismatchInfo();
			mismatch_->Parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_data__size = 8;
			}
			break;
		case 1:
			// Parse "auth_stat"
			{
			// Checking out-of-bound for "RPC_RejectedReply:auth_stat"
			if ( (t_begin_of_data + 4) + (4) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("RPC_RejectedReply:auth_stat",
					(4) + (4), 
					(t_end_of_data) - (t_begin_of_data));
				}
			auth_stat_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 4))));
			// Evaluate 'let' and 'withinput' fields
			t_data__size = 4;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("RPC_RejectedReply", data_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_RejectedReply__size;
	const_byteptr const t_dataptr_after_data = (t_begin_of_data + 4) + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_RPC_RejectedReply__size = t_dataptr_after_data - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_RejectedReply__size) <= t_end_of_data);
	return t_RPC_RejectedReply__size;
	}

RPC_MismatchInfo::RPC_MismatchInfo()
	{
	hi_ = 0;
	low_ = 0;
	}

RPC_MismatchInfo::~RPC_MismatchInfo()
	{
	}

int RPC_MismatchInfo::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_MismatchInfo"
	if ( t_begin_of_data + (8) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_MismatchInfo",
			(0) + (8), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "hi"
	hi_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "low"
	low_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 4))));
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (8) <= t_end_of_data);
	return 8;
	}

RPC_Opaque::RPC_Opaque()
	{
	length_ = 0;
	data_ = 0;
	data__elem_ = 0;
	}

RPC_Opaque::~RPC_Opaque()
	{
	delete data_;
	}

int RPC_Opaque::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_Opaque:length"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_Opaque:length",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "length"
	length_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "data"
	int t_data__arraylength;
	t_data__arraylength = length();
	if ( t_begin_of_data + t_data__arraylength > t_end_of_data + 1 )
		{
		t_data__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_data__arraylength < 0 )
		{
		t_data__arraylength = 0;
		}
	data__elem_ = 0;
	int t_data__elem__it;
	t_data__elem__it = 0;
	int t_data__size;
	data_ = new vector<uint8>;
	data_->reserve(t_data__arraylength);
	const_byteptr t_data__elem__dataptr = (t_begin_of_data + 4);
	for (; t_data__elem__it < t_data__arraylength; ++t_data__elem__it)
		{
		// Check &until(data__elem__dataptr >= end_of_data)
		if ( t_data__elem__dataptr >= t_end_of_data )
			{
			goto end_of_data;
			}
		// Checking out-of-bound for "RPC_Opaque:data__elem"
		if ( t_data__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("RPC_Opaque:data__elem",
				((t_data__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		data__elem_ = *((uint8 const *) (t_data__elem__dataptr));
		// Evaluate 'let' and 'withinput' fields
		data_->push_back(data__elem_);
		t_data__elem__dataptr += 1;
		BINPAC_ASSERT(t_data__elem__dataptr <= t_end_of_data);
		}
end_of_data: ;
	t_data__size = t_data__elem__dataptr - ((t_begin_of_data + 4));
	// Evaluate 'let' and 'withinput' fields
	
	
	int t_RPC_Opaque__size;
	const_byteptr const t_dataptr_after_data = (t_begin_of_data + 4) + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	int pad__size = (t_dataptr_after_data - t_begin_of_data) % 4;
	pad__size = (pad__size == 0) ? 0 : 4 - pad__size;
	const_byteptr const t_dataptr_after_pad = t_dataptr_after_data + pad__size;
	t_RPC_Opaque__size = t_dataptr_after_pad - t_begin_of_data;
	// Checking out-of-bound for "RPC_Opaque"
	if ( t_begin_of_data + (t_RPC_Opaque__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_Opaque",
			(0) + (t_RPC_Opaque__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_Opaque__size) <= t_end_of_data);
	return t_RPC_Opaque__size;
	}

RPC_OpaqueAuth::RPC_OpaqueAuth()
	{
	flavor_ = 0;
	opaque_ = 0;
	}

RPC_OpaqueAuth::~RPC_OpaqueAuth()
	{
	delete opaque_;
	opaque_ = 0;
	}

int RPC_OpaqueAuth::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "RPC_OpaqueAuth:flavor"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("RPC_OpaqueAuth:flavor",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "flavor"
	flavor_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "opaque"
	opaque_ = new RPC_Opaque();
	int t_opaque__size;
	t_opaque__size = opaque_->Parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	int t_RPC_OpaqueAuth__size;
	const_byteptr const t_dataptr_after_opaque = (t_begin_of_data + 4) + (t_opaque__size);
	BINPAC_ASSERT(t_dataptr_after_opaque <= t_end_of_data);
	t_RPC_OpaqueAuth__size = t_dataptr_after_opaque - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RPC_OpaqueAuth__size) <= t_end_of_data);
	return t_RPC_OpaqueAuth__size;
	}

RPC_Params::RPC_Params(RPC_Call * call)
	{
	val_case_index_ = -1;
	stub_ = 0;
	stub__elem_ = 0;
	portmap_ = 0;
	call_ = call;
	}

RPC_Params::~RPC_Params()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "portmap"
			{
			delete portmap_;
			portmap_ = 0;
			}
			break;
		default:
			// Clean up "stub"
			{
			delete stub_;
			}
			break;
		}
	}

int RPC_Params::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = RPC_Service(call());
	switch ( val_case_index() )
		{
		case 1:
			// Parse "portmap"
			{
			portmap_ = new PortmapParams(call());
			int t_portmap__size;
			t_portmap__size = portmap_->Parse(t_begin_of_data, t_end_of_data, t_context, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_portmap__size;
			}
			break;
		default:
			// Parse "stub"
			{
			int t_stub__arraylength;
			t_stub__arraylength = (t_end_of_data) - (t_begin_of_data);
			stub__elem_ = 0;
			int t_stub__elem__it;
			t_stub__elem__it = 0;
			int t_stub__size;
			stub_ = new vector<uint8>;
			stub_->reserve(t_stub__arraylength);
			const_byteptr t_stub__elem__dataptr = t_begin_of_data;
			for (; t_stub__elem__it < t_stub__arraylength; ++t_stub__elem__it)
				{
				// Check &until(stub__elem__dataptr >= end_of_data)
				if ( t_stub__elem__dataptr >= t_end_of_data )
					{
					goto end_of_stub;
					}
				stub__elem_ = *((uint8 const *) (t_stub__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				stub_->push_back(stub__elem_);
				t_stub__elem__dataptr += 1;
				BINPAC_ASSERT(t_stub__elem__dataptr <= t_end_of_data);
				}
		end_of_stub: ;
			t_stub__size = t_stub__elem__dataptr - (t_begin_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_stub__size;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

RPC_Results::RPC_Results(RPC_Call * call)
	{
	val_case_index_ = -1;
	stub_ = 0;
	stub__elem_ = 0;
	portmap_ = 0;
	call_ = call;
	}

RPC_Results::~RPC_Results()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "portmap"
			{
			delete portmap_;
			portmap_ = 0;
			}
			break;
		default:
			// Clean up "stub"
			{
			delete stub_;
			}
			break;
		}
	}

int RPC_Results::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = RPC_Service(call());
	switch ( val_case_index() )
		{
		case 1:
			// Parse "portmap"
			{
			portmap_ = new PortmapResults(call());
			int t_portmap__size;
			t_portmap__size = portmap_->Parse(t_begin_of_data, t_end_of_data, t_context, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_portmap__size;
			}
			break;
		default:
			// Parse "stub"
			{
			int t_stub__arraylength;
			t_stub__arraylength = (t_end_of_data) - (t_begin_of_data);
			stub__elem_ = 0;
			int t_stub__elem__it;
			t_stub__elem__it = 0;
			int t_stub__size;
			stub_ = new vector<uint8>;
			stub_->reserve(t_stub__arraylength);
			const_byteptr t_stub__elem__dataptr = t_begin_of_data;
			for (; t_stub__elem__it < t_stub__arraylength; ++t_stub__elem__it)
				{
				// Check &until(stub__elem__dataptr >= end_of_data)
				if ( t_stub__elem__dataptr >= t_end_of_data )
					{
					goto end_of_stub;
					}
				stub__elem_ = *((uint8 const *) (t_stub__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				stub_->push_back(stub__elem_);
				t_stub__elem__dataptr += 1;
				BINPAC_ASSERT(t_stub__elem__dataptr <= t_end_of_data);
				}
		end_of_stub: ;
			t_stub__size = t_stub__elem__dataptr - (t_begin_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_stub__size;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

BroVal RPC_BuildCallVal(RPC_Call * call)
	{
	BroVal t_t_var_002;
	switch ( RPC_Service(call) )
		{
		case 1:
			t_t_var_002 = PortmapBuildCallVal(call, call->params()->portmap());
			break;
		default:
			t_t_var_002 = NULL;
			break;
		}
	return static_cast<BroVal>(t_t_var_002);
	}

EnumRPCStatus RPC_Status(RPC_Reply * reply)
	{
	uint32 t_t_var_003;
	switch ( reply->stat() )
		{
		case 0:
			t_t_var_003 = reply->areply()->stat();
			break;
		case 1:
			int t_t_var_004;
			switch ( reply->rreply()->stat() )
				{
				case 0:
					t_t_var_004 = RPC_STATUS_MISMATCH;
					break;
				case 1:
					t_t_var_004 = RPC_STATUS_AUTH_ERROR;
					break;
				default:
					throw ExceptionInvalidCaseIndex("./rpc-analyzer.pac:60", reply->rreply()->stat());
					break;
				}
			t_t_var_003 = t_t_var_004;
			break;
		default:
			throw ExceptionInvalidCaseIndex("./rpc-analyzer.pac:61", reply->stat());
			break;
		}
	return static_cast<EnumRPCStatus>(t_t_var_003);
	}

RPC_Conn::RPC_Conn(BroAnalyzer const & bro_analyzer)
	{
	upflow_ = new RPC_Flow(this, true);
	downflow_ = new RPC_Flow(this, false);
	bro_analyzer_ = bro_analyzer;
	}

RPC_Conn::~RPC_Conn()
	{
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void RPC_Conn::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void RPC_Conn::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void RPC_Conn::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();
	}

RPC_Call * RPC_Conn::FindCall(uint32 xid)
	{

		RPC_CallTable::const_iterator it = call_table.find(xid);
		return it == call_table.end() ? 0 : it->second;
		
	}

bool RPC_Conn::NewCall(uint32 xid, RPC_Call * call)
	{

		if ( call_table.find(xid) != call_table.end() )
			{
			// Compare retransmission with the original.
			RPC_Call* orig_call = call_table[xid];
			if ( RPC_CompareRexmit(orig_call, call) )
				Weird("RPC_rexmit_inconsistency");
			return false;
			}
		else
			{
			// Add reference count to msg.
			call->msg()->Ref();
			call_table[xid] = call;
			return true;
			}
		
	}

bool RPC_Conn::RPC_CompareRexmit(RPC_Call * orig_call, RPC_Call * new_call)
	{

		if ( orig_call->msg()->length() != new_call->msg()->length() )
			return true;

		return memcmp(orig_call->msg_source_data().begin(),
		              new_call->msg_source_data().begin(),
		              orig_call->msg()->length()) != 0;
		
	}

void RPC_Conn::FinishCall(RPC_Call * call)
	{

		call_table.erase(call->msg()->xid());
		Unref(call->msg());
		
	}

void RPC_Conn::Timeout()
	{

		for ( RPC_CallTable::const_iterator it = call_table.begin();
		      it != call_table.end(); ++it )
			{
			RPC_Call* call = it->second;
			RPC_CallFailed(this, call, RPC_STATUS_TIMEOUT);
			Unref(call->msg());
			}

		call_table.clear();
		
	}

void RPC_Conn::Weird(string const & msg)
	{

		bro_analyzer()->Weird(msg.c_str());
		
	}

bool RPC_Conn::ProcessPortmapReply(PortmapResults * results)
	{

		RPC_Call const* call = results->call();
		PortmapParams const* params = call->params()->portmap();

		switch ( call->proc() ) {
		case PMAPPROC_NULL:
			bro_event_pm_request_null(bro_analyzer(), bro_analyzer()->Conn());
			break;

		case PMAPPROC_SET:
			bro_event_pm_request_set(bro_analyzer(),
				bro_analyzer()->Conn(),
				call->call_val(), results->set());
			break;

		case PMAPPROC_UNSET:
			bro_event_pm_request_unset(bro_analyzer(),
				bro_analyzer()->Conn(),
				call->call_val(), results->unset());
			break;

		case PMAPPROC_GETPORT:
			bro_event_pm_request_getport(bro_analyzer(),
				bro_analyzer()->Conn(),
				call->call_val(),
				PortmapBuildPortVal(results->getport(),
					params->mapping()->proto()));
			break;

		case PMAPPROC_DUMP:
			bro_event_pm_request_dump(bro_analyzer(),
				bro_analyzer()->Conn(),
				PortmapBuildDumpVal(results->dump()));
			break;

		case PMAPPROC_CALLIT:
			bro_event_pm_request_callit(bro_analyzer(),
				bro_analyzer()->Conn(),
				call->call_val(),
				new PortVal(results->callit()->port(),
					    TRANSPORT_UDP));
			break;

		default:
			return false;
		}

		return true;
		
	}

RPC_Flow::RPC_Flow(RPC_Conn * connection, bool is_orig)
	{
	connection_ = connection;
	is_orig_ = is_orig;
	dataunit_ = 0;
	context_ = 0;
	}

RPC_Flow::~RPC_Flow()
	{
	Unref(dataunit_);
	dataunit_ = 0;
	delete context_;
	context_ = 0;
	}

void RPC_Flow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		dataunit_ = new RPC_Message();
		context_ = new ContextSunRPC(connection(), this);
		int t_dataunit__size;
		t_dataunit__size = dataunit_->Parse(t_begin_of_data, t_end_of_data, context_);
		// Evaluate 'let' and 'withinput' fields
		Unref(dataunit_);
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		}
	catch ( Exception const &e )
		{
		Unref(dataunit_);
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		throw e;
		}
	}

void RPC_Flow::NewGap(int gap_length)
	{
	}
void RPC_Flow::FlowEOF()
	{
	}
bool RPC_Flow::ProcessCall(RPC_Call * call)
	{

		if ( ! is_orig() )
			Weird("responder_RPC_call");
		return true;
		
	}

bool RPC_Flow::ProcessReply(RPC_Reply * reply)
	{

		if ( is_orig() )
			Weird("originator_RPC_reply");

		RPC_Call* call = reply->call();
		if ( ! call )
			{
			Weird("unpaired_RPC_response");
			return false;
			}

		bro_event_rpc_call(connection()->bro_analyzer(),
		                   connection()->bro_analyzer()->Conn(),
		                   call->prog(),
		                   call->vers(),
		                   call->proc(),
		                   reply->status(),
		                   call->start_time(),
		                   call->msg()->length(),
		                   reply->msg()->length());

		if ( ! reply->success() )
			RPC_CallFailed(connection(), call, reply->status());

		connection()->FinishCall(call);

		return true;
		
	}

void RPC_Flow::Weird(string const & msg)
	{

		connection()->Weird(msg);
		
	}

bool RPC_CallFailed(RPC_Conn * connection, RPC_Call * call, EnumRPCStatus status)
	{
	int t_t_var_005;
	switch ( RPC_Service(call) )
		{
		case 1:
			t_t_var_005 = PortmapCallFailed(connection, call, status);
			break;
		default:
			t_t_var_005 = false;
			break;
		}
	return static_cast<bool>(t_t_var_005);
	}

PortmapParams::PortmapParams(RPC_Call * call)
	{
	val_case_index_ = -1;
	mapping_ = 0;
	callit_ = 0;
	call_ = call;
	}

PortmapParams::~PortmapParams()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "null"
			{
			}
			break;
		case 1:
		case 2:
		case 3:
			// Clean up "mapping"
			{
			delete mapping_;
			mapping_ = 0;
			}
			break;
		case 4:
			// Clean up "dump"
			{
			}
			break;
		case 5:
			// Clean up "callit"
			{
			delete callit_;
			callit_ = 0;
			}
			break;
		}
	}

int PortmapParams::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = call()->proc();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "null"
			{
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 0;
			}
			break;
		case 1:
		case 2:
		case 3:
			// Parse "mapping"
			{
			mapping_ = new PortmapMapping();
			mapping_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 16;
			}
			break;
		case 4:
			// Parse "dump"
			{
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 0;
			}
			break;
		case 5:
			// Parse "callit"
			{
			callit_ = new PortmapCallItParams();
			int t_callit__size;
			t_callit__size = callit_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_callit__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("PortmapParams", val_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

PortmapResults::PortmapResults(RPC_Call * call)
	{
	val_case_index_ = -1;
	set_ = 0;
	unset_ = 0;
	getport_ = 0;
	dump_ = 0;
	callit_ = 0;
	call_ = call;
	}

PortmapResults::~PortmapResults()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "null"
			{
			}
			break;
		case 1:
			// Clean up "set"
			{
			}
			break;
		case 2:
			// Clean up "unset"
			{
			}
			break;
		case 3:
			// Clean up "getport"
			{
			}
			break;
		case 4:
			// Clean up "dump"
			{
			delete dump_;
			dump_ = 0;
			}
			break;
		case 5:
			// Clean up "callit"
			{
			delete callit_;
			callit_ = 0;
			}
			break;
		}
	}

int PortmapResults::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = call()->proc();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "null"
			{
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 0;
			}
			break;
		case 1:
			// Parse "set"
			{
			// Checking out-of-bound for "PortmapResults:set"
			if ( t_begin_of_data + (4) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("PortmapResults:set",
					(0) + (4), 
					(t_end_of_data) - (t_begin_of_data));
				}
			set_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 4;
			}
			break;
		case 2:
			// Parse "unset"
			{
			// Checking out-of-bound for "PortmapResults:unset"
			if ( t_begin_of_data + (4) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("PortmapResults:unset",
					(0) + (4), 
					(t_end_of_data) - (t_begin_of_data));
				}
			unset_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 4;
			}
			break;
		case 3:
			// Parse "getport"
			{
			// Checking out-of-bound for "PortmapResults:getport"
			if ( t_begin_of_data + (4) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("PortmapResults:getport",
					(0) + (4), 
					(t_end_of_data) - (t_begin_of_data));
				}
			getport_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
			// Evaluate 'let' and 'withinput' fields
			t_val__size = 4;
			}
			break;
		case 4:
			// Parse "dump"
			{
			dump_ = new PortmapDumpResults();
			int t_dump__size;
			t_dump__size = dump_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_dump__size;
			}
			break;
		case 5:
			// Parse "callit"
			{
			callit_ = new PortmapCallItResults();
			int t_callit__size;
			t_callit__size = callit_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_callit__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("PortmapResults", val_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	action_reply_ = t_context->connection()->ProcessPortmapReply(this);
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

PortmapMapping::PortmapMapping()
	{
	prog_ = 0;
	vers_ = 0;
	proto_ = 0;
	port_ = 0;
	}

PortmapMapping::~PortmapMapping()
	{
	}

int PortmapMapping::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "PortmapMapping"
	if ( t_begin_of_data + (16) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("PortmapMapping",
			(0) + (16), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "prog"
	prog_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "vers"
	vers_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 4))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "proto"
	proto_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 8))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "port"
	port_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 12))));
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (16) <= t_end_of_data);
	return 16;
	}

PortmapCallItParams::PortmapCallItParams()
	{
	prog_ = 0;
	vers_ = 0;
	proc_ = 0;
	params_ = 0;
	}

PortmapCallItParams::~PortmapCallItParams()
	{
	delete params_;
	params_ = 0;
	}

int PortmapCallItParams::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "PortmapCallItParams:proc"
	if ( (t_begin_of_data + 8) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("PortmapCallItParams:proc",
			(8) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "prog"
	prog_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "vers"
	vers_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 4))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "proc"
	proc_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 8))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "params"
	params_ = new RPC_Opaque();
	int t_params__size;
	t_params__size = params_->Parse((t_begin_of_data + 12), t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	int t_PortmapCallItParams__size;
	const_byteptr const t_dataptr_after_params = (t_begin_of_data + 12) + (t_params__size);
	BINPAC_ASSERT(t_dataptr_after_params <= t_end_of_data);
	t_PortmapCallItParams__size = t_dataptr_after_params - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_PortmapCallItParams__size) <= t_end_of_data);
	return t_PortmapCallItParams__size;
	}

PortmapDumpEntry::PortmapDumpEntry()
	{
	cont_ = 0;
	optmapping_case_index_ = -1;
	mapping_ = 0;
	}

PortmapDumpEntry::~PortmapDumpEntry()
	{
	switch ( optmapping_case_index() )
		{
		case 0:
			// Clean up "none"
			{
			}
			break;
		default:
			// Clean up "mapping"
			{
			delete mapping_;
			mapping_ = 0;
			}
			break;
		}
	}

int PortmapDumpEntry::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "PortmapDumpEntry:cont"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("PortmapDumpEntry:cont",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "cont"
	cont_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "optmapping"
	int t_optmapping__size;
	optmapping_case_index_ = cont();
	switch ( optmapping_case_index() )
		{
		case 0:
			// Parse "none"
			{
			// Evaluate 'let' and 'withinput' fields
			t_optmapping__size = 0;
			}
			break;
		default:
			// Parse "mapping"
			{
			mapping_ = new PortmapMapping();
			mapping_->Parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_optmapping__size = 16;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_PortmapDumpEntry__size;
	const_byteptr const t_dataptr_after_optmapping = (t_begin_of_data + 4) + (t_optmapping__size);
	BINPAC_ASSERT(t_dataptr_after_optmapping <= t_end_of_data);
	t_PortmapDumpEntry__size = t_dataptr_after_optmapping - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_PortmapDumpEntry__size) <= t_end_of_data);
	return t_PortmapDumpEntry__size;
	}

PortmapDumpResults::PortmapDumpResults()
	{
	val_ = 0;
	val__elem_ = 0;
	}

PortmapDumpResults::~PortmapDumpResults()
	{
	delete val__elem_;
	val__elem_ = 0;
	if ( val() )
		{
		for ( int i = 0; i < (int) val()->size(); ++i )
			{
			PortmapDumpEntry * val__elem_ = (*val_)[i];
			delete val__elem_;
			val__elem_ = 0;
			}
		}
	delete val_;
	}

int PortmapDumpResults::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	int t_val__arraylength;
	val__elem_ = 0;
	int t_val__elem__it;
	t_val__elem__it = 0;
	int t_val__size;
	val_ = new vector<PortmapDumpEntry *>;
	const_byteptr t_val__elem__dataptr = t_begin_of_data;
	for (; /* forever */; ++t_val__elem__it)
		{
		// Check &until(val__elem__dataptr >= end_of_data)
		if ( t_val__elem__dataptr >= t_end_of_data )
			{
			val__elem_ = 0;
			goto end_of_val;
			}
		val__elem_ = new PortmapDumpEntry();
		int t_val__elem__size;
		t_val__elem__size = val__elem_->Parse(t_val__elem__dataptr, t_end_of_data, t_byteorder);
		// Evaluate 'let' and 'withinput' fields
		val_->push_back(val__elem_);
		t_val__elem__dataptr += t_val__elem__size;
		BINPAC_ASSERT(t_val__elem__dataptr <= t_end_of_data);
		// Check &until( ( @$element->cont@ != ((int) 1) ) )
		if (  ( val__elem_->cont() != 1 )  )
			{
			val__elem_ = 0;
			goto end_of_val;
			}
		val__elem_ = 0;
		}
end_of_val: ;
	t_val__size = t_val__elem__dataptr - (t_begin_of_data);
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

PortmapCallItResults::PortmapCallItResults()
	{
	port_ = 0;
	results_ = 0;
	}

PortmapCallItResults::~PortmapCallItResults()
	{
	delete results_;
	results_ = 0;
	}

int PortmapCallItResults::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "PortmapCallItResults:port"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("PortmapCallItResults:port",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "port"
	port_ = FixByteOrder(t_byteorder, *((uint32 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "results"
	results_ = new RPC_Opaque();
	int t_results__size;
	t_results__size = results_->Parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	int t_PortmapCallItResults__size;
	const_byteptr const t_dataptr_after_results = (t_begin_of_data + 4) + (t_results__size);
	BINPAC_ASSERT(t_dataptr_after_results <= t_end_of_data);
	t_PortmapCallItResults__size = t_dataptr_after_results - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_PortmapCallItResults__size) <= t_end_of_data);
	return t_PortmapCallItResults__size;
	}

BroVal PortmapBuildCallVal(RPC_Call * call, PortmapParams * params)
	{
	BroVal t_t_var_006;
	switch ( call->proc() )
		{
		case 0:
		case 4:
			t_t_var_006 = NULL;
			break;
		case 1:
		case 2:
			t_t_var_006 = PortmapBuildMappingVal(params->mapping());
			break;
		case 3:
			t_t_var_006 = PortmapBuildPortRequest(params->mapping());
			break;
		case 5:
			t_t_var_006 = PortmapBuildCallItVal(params->callit());
			break;
		default:
			throw ExceptionInvalidCaseIndex("./portmap-analyzer.pac:32", call->proc());
			break;
		}
	return static_cast<BroVal>(t_t_var_006);
	}

BroPortVal PortmapBuildPortVal(uint32 port, uint32 proto)
	{

	// TODO: replace port with CheckPort(port)
	return new PortVal(port, proto == IPPROTO_TCP ?
					TRANSPORT_TCP : TRANSPORT_UDP);
	
	}

BroVal PortmapBuildMappingVal(PortmapMapping * params)
	{

	RecordVal* mapping = new RecordVal(pm_mapping);

	mapping->Assign(0, new Val(params->prog(), TYPE_COUNT));
	mapping->Assign(1, new Val(params->vers(), TYPE_COUNT));
	mapping->Assign(2, PortmapBuildPortVal(params->port(),
	                                       params->proto()));

	return mapping;
	
	}

BroVal PortmapBuildPortRequest(PortmapMapping * params)
	{

	RecordVal* request = new RecordVal(pm_port_request);

	request->Assign(0, new Val(params->prog(), TYPE_COUNT));
	request->Assign(1, new Val(params->vers(), TYPE_COUNT));
	request->Assign(2, new Val(params->proto() == IPPROTO_TCP, TYPE_BOOL));

	return request;
	
	}

BroVal PortmapBuildCallItVal(PortmapCallItParams * params)
	{

	RecordVal* c = new RecordVal(pm_callit_request);

	c->Assign(0, new Val(params->prog(), TYPE_COUNT));
	c->Assign(1, new Val(params->vers(), TYPE_COUNT));
	c->Assign(2, new Val(params->proc(), TYPE_COUNT));
	c->Assign(3, new Val(params->params()->length(), TYPE_COUNT));

	return c;
	
	}

BroVal PortmapBuildDumpVal(PortmapDumpResults * params)
	{

	TableVal* mappings = new TableVal(pm_mappings);

	for ( int i = 0; i < params->size(); ++i )
		{
		Val* m = PortmapBuildMappingVal((*params)[i]->mapping());
		Val* index = new Val(i + 1, TYPE_COUNT);
		mappings->Assign(index, m);
		Unref(index);
		}

	return mappings;
	
	}

bool PortmapCallFailed(RPC_Conn * connection, RPC_Call * call, EnumRPCStatus status)
	{

	// BroEnum::rpc_status st = static_cast<BroEnum::rpc_status>(status);
	BroEnum::rpc_status st = (BroEnum::rpc_status) status;

	switch ( call->proc() ) {
	case PMAPPROC_NULL:
		bro_event_pm_attempt_null(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st);
		break;

	case PMAPPROC_SET:
		bro_event_pm_attempt_set(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st, call->call_val());
		break;

	case PMAPPROC_UNSET:
		bro_event_pm_attempt_unset(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st, call->call_val());
		break;

	case PMAPPROC_GETPORT:
		bro_event_pm_attempt_getport(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st, call->call_val());
		break;

	case PMAPPROC_DUMP:
		bro_event_pm_attempt_dump(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st);
		break;

	case PMAPPROC_CALLIT:
		bro_event_pm_attempt_callit(connection->bro_analyzer(),
			connection->bro_analyzer()->Conn(), st, call->call_val());
		break;

	default:
		return false;
	}

	return true;
	
	}

} // namespace SunRPC
}  // namespace binpac
