// This file is automatically generated from ./rpc.pac.

#ifndef __rpc_pac_h
#define __rpc_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


#include <map>
using namespace std;

namespace binpac {

namespace SunRPC {
class ContextSunRPC;
enum EnumRPCService {
	RPC_SERVICE_UNKNOWN,
	RPC_SERVICE_PORTMAP,
};
enum RPC_MsgType {
	RPC_CALL = 0,
	RPC_REPLY = 1,
};
enum RPC_ReplyStat {
	MSG_ACCEPTED = 0,
	MSG_DENIED = 1,
};
enum RPC_AcceptStat {
	SUCCESS = 0,
	PROG_UNAVAIL = 1,
	PROG_MISMATCH = 2,
	PROC_UNAVAIL = 3,
	GARBAGE_ARGS = 4,
	SYSTEM_ERR = 5,
};
enum RPC_RejectStat {
	RPC_MISMATCH = 0,
	AUTH_ERROR = 1,
};
enum RPC_AuthStat {
	AUTH_OK = 0,
	AUTH_BADCRED = 1,
	AUTH_REJECTEDCRED = 2,
	AUTH_BADVERF = 3,
	AUTH_REJECTEDVERF = 4,
	AUTH_TOOWEAK = 5,
	AUTH_INVALIDRESP = 6,
	AUTH_FAILED = 7,
};
class RPC_Message;
class RPC_Call;
class RPC_Reply;
class RPC_AcceptedReply;
class RPC_RejectedReply;
class RPC_MismatchInfo;
class RPC_Opaque;
class RPC_OpaqueAuth;
class RPC_Params;
class RPC_Results;
enum EnumRPCStatus {
	RPC_STATUS_SUCCESS = 0,
	RPC_STATUS_PROG_UNAVAIL = 1,
	RPC_STATUS_PROG_MISMATCH = 2,
	RPC_STATUS_PROC_UNAVAIL = 3,
	RPC_STATUS_GARBAGE_ARGS = 4,
	RPC_STATUS_SYSTEM_ERR = 5,
	RPC_STATUS_TIMEOUT = 6,
	RPC_STATUS_MISMATCH = 7,
	RPC_STATUS_AUTH_ERROR = 8,
	RPC_STATUS_UNKNOWN_ERROR = 9,
};
class RPC_Conn;
class RPC_Flow;
enum PortmapProc {
	PMAPPROC_NULL = 0,
	PMAPPROC_SET = 1,
	PMAPPROC_UNSET = 2,
	PMAPPROC_GETPORT = 3,
	PMAPPROC_DUMP = 4,
	PMAPPROC_CALLIT = 5,
};
class PortmapParams;
class PortmapResults;
class PortmapMapping;
class PortmapCallItParams;
class PortmapDumpEntry;
class PortmapDumpResults;
class PortmapCallItResults;
} // namespace SunRPC

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace SunRPC {

class ContextSunRPC
{
public:
	ContextSunRPC(RPC_Conn * connection, RPC_Flow * flow);
	~ContextSunRPC();
	
	// Member access functions
	RPC_Conn * connection() const { return connection_; }
	RPC_Flow * flow() const { return flow_; }
	
protected:
	RPC_Conn * connection_;
	RPC_Flow * flow_;
};

EnumRPCService RPC_Service(uint32 prog, uint32 vers);

class RPC_Message : public binpac::RefCount
{
public:
	RPC_Message();
	~RPC_Message();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context);
	
	// Member access functions
	uint32 xid() const { return xid_; }
	uint32 msg_type() const { return msg_type_; }
	int msg_body_case_index() const	{ return msg_body_case_index_; }
	RPC_Call * call() const
		{
		switch ( msg_body_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:82:call", msg_body_case_index(), "RPC_CALL");
				break;
			}
		return call_;
		}
	RPC_Reply * reply() const
		{
		switch ( msg_body_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:83:reply", msg_body_case_index(), "RPC_REPLY");
				break;
			}
		return reply_;
		}
	int byteorder() const { return byteorder_; }
	int length() const { return length_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint32 xid_;
	uint32 msg_type_;
	int msg_body_case_index_;
	RPC_Call * call_;
	RPC_Reply * reply_;
	int byteorder_;
	int length_;
	const_bytestring sourcedata_;
};


class RPC_Call
{
public:
	RPC_Call(RPC_Message * msg);
	~RPC_Call();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	uint32 rpcvers() const { return rpcvers_; }
	uint32 prog() const { return prog_; }
	uint32 vers() const { return vers_; }
	uint32 proc() const { return proc_; }
	RPC_OpaqueAuth * cred() const { return cred_; }
	RPC_OpaqueAuth * verf() const { return verf_; }
	RPC_Params * params() const { return params_; }
	RPC_Message * msg() const { return msg_; }
	EnumRPCService service() const { return service_; }
	bytestring const & msg_source_data() const { return msg_source_data_; }
	bool newcall() const { return newcall_; }
	double start_time() const { return start_time_; }
	BroVal const & call_val() const { return call_val_; }
	bool action_call() const { return action_call_; }
	
protected:
	uint32 rpcvers_;
	uint32 prog_;
	uint32 vers_;
	uint32 proc_;
	RPC_OpaqueAuth * cred_;
	RPC_OpaqueAuth * verf_;
	RPC_Params * params_;
	RPC_Message * msg_;
	EnumRPCService service_;
	bytestring msg_source_data_;
	bool newcall_;
	double start_time_;
	BroVal call_val_;
	bool action_call_;
};


class RPC_Reply
{
public:
	RPC_Reply(RPC_Message * msg);
	~RPC_Reply();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	uint32 stat() const { return stat_; }
	int reply_case_index() const	{ return reply_case_index_; }
	RPC_AcceptedReply * areply() const
		{
		switch ( reply_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:115:areply", reply_case_index(), "MSG_ACCEPTED");
				break;
			}
		return areply_;
		}
	RPC_RejectedReply * rreply() const
		{
		switch ( reply_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:116:rreply", reply_case_index(), "MSG_DENIED");
				break;
			}
		return rreply_;
		}
	RPC_Message * msg() const { return msg_; }
	RPC_Call * call() const { return call_; }
	bool success() const { return success_; }
	EnumRPCStatus status() const { return status_; }
	bool action_reply() const { return action_reply_; }
	
protected:
	uint32 stat_;
	int reply_case_index_;
	RPC_AcceptedReply * areply_;
	RPC_RejectedReply * rreply_;
	RPC_Message * msg_;
	RPC_Call * call_;
	bool success_;
	EnumRPCStatus status_;
	bool action_reply_;
};


class RPC_AcceptedReply
{
public:
	RPC_AcceptedReply(RPC_Call * call);
	~RPC_AcceptedReply();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	RPC_OpaqueAuth * verf() const { return verf_; }
	uint32 stat() const { return stat_; }
	int data_case_index() const	{ return data_case_index_; }
	RPC_Results * results() const
		{
		switch ( data_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:127:results", data_case_index(), "SUCCESS");
				break;
			}
		return results_;
		}
	RPC_MismatchInfo * mismatch() const
		{
		switch ( data_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:128:mismatch", data_case_index(), "PROG_MISMATCH");
				break;
			}
		return mismatch_;
		}
	RPC_Call * call() const { return call_; }
	
protected:
	RPC_OpaqueAuth * verf_;
	uint32 stat_;
	int data_case_index_;
	RPC_Results * results_;
	RPC_MismatchInfo * mismatch_;
	RPC_Call * call_;
};


class RPC_RejectedReply
{
public:
	RPC_RejectedReply(RPC_Call * call);
	~RPC_RejectedReply();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	uint32 stat() const { return stat_; }
	int data_case_index() const	{ return data_case_index_; }
	RPC_MismatchInfo * mismatch() const
		{
		switch ( data_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:136:mismatch", data_case_index(), "RPC_MISMATCH");
				break;
			}
		return mismatch_;
		}
	uint32 auth_stat() const
		{
		switch ( data_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./rpc-protocol.pac:137:auth_stat", data_case_index(), "AUTH_ERROR");
				break;
			}
		return auth_stat_;
		}
	RPC_Call * call() const { return call_; }
	
protected:
	uint32 stat_;
	int data_case_index_;
	RPC_MismatchInfo * mismatch_;
	uint32 auth_stat_;
	RPC_Call * call_;
};


class RPC_MismatchInfo
{
public:
	RPC_MismatchInfo();
	~RPC_MismatchInfo();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 hi() const { return hi_; }
	uint32 low() const { return low_; }
	
protected:
	uint32 hi_;
	uint32 low_;
};


class RPC_Opaque
{
public:
	RPC_Opaque();
	~RPC_Opaque();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 length() const { return length_; }
	vector<uint8> * data() const { return data_; }
	
protected:
	uint32 length_;
	vector<uint8> * data_;
	uint8 data__elem_;
};


class RPC_OpaqueAuth
{
public:
	RPC_OpaqueAuth();
	~RPC_OpaqueAuth();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 flavor() const { return flavor_; }
	RPC_Opaque * opaque() const { return opaque_; }
	
protected:
	uint32 flavor_;
	RPC_Opaque * opaque_;
};


class RPC_Params
{
public:
	RPC_Params(RPC_Call * call);
	~RPC_Params();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	vector<uint8> * stub() const
		{
		return stub_;
		}
	PortmapParams * portmap() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:13:portmap", val_case_index(), "RPC_SERVICE_PORTMAP");
				break;
			}
		return portmap_;
		}
	RPC_Call * call() const { return call_; }
	
protected:
	int val_case_index_;
	vector<uint8> * stub_;
	uint8 stub__elem_;
	PortmapParams * portmap_;
	RPC_Call * call_;
};


class RPC_Results
{
public:
	RPC_Results(RPC_Call * call);
	~RPC_Results();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	vector<uint8> * stub() const
		{
		return stub_;
		}
	PortmapResults * portmap() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:17:portmap", val_case_index(), "RPC_SERVICE_PORTMAP");
				break;
			}
		return portmap_;
		}
	RPC_Call * call() const { return call_; }
	
protected:
	int val_case_index_;
	vector<uint8> * stub_;
	uint8 stub__elem_;
	PortmapResults * portmap_;
	RPC_Call * call_;
};

BroVal RPC_BuildCallVal(RPC_Call * call);
EnumRPCStatus RPC_Status(RPC_Reply * reply);

class RPC_Conn : public binpac::ConnectionAnalyzer
{
public:
	RPC_Conn(BroAnalyzer const & bro_analyzer);
	~RPC_Conn();
	
	// Member access functions
	RPC_Flow * upflow() const { return upflow_; }
	RPC_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	RPC_Call * FindCall(uint32 xid);
	bool NewCall(uint32 xid, RPC_Call * call);
	bool RPC_CompareRexmit(RPC_Call * orig_call, RPC_Call * new_call);
	void FinishCall(RPC_Call * call);
	void Timeout();
	void Weird(string const & msg);
	bool ProcessPortmapReply(PortmapResults * results);
	
protected:
	
	// Additional members

		typedef ::std::map<uint32, RPC_Call*> RPC_CallTable;
		RPC_CallTable call_table;
	
	RPC_Flow * upflow_;
	RPC_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class RPC_Flow : public binpac::FlowAnalyzer
{
public:
	RPC_Flow(RPC_Conn * connection, bool is_orig);
	~RPC_Flow();
	
	// Member access functions
	RPC_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	bool ProcessCall(RPC_Call * call);
	bool ProcessReply(RPC_Reply * reply);
	void Weird(string const & msg);
	
protected:
	RPC_Message * dataunit_;
	ContextSunRPC * context_;
	RPC_Conn * connection_;
	bool is_orig_;
};

bool RPC_CallFailed(RPC_Conn * connection, RPC_Call * call, EnumRPCStatus status);

class PortmapParams
{
public:
	PortmapParams(RPC_Call * call);
	~PortmapParams();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	PortmapMapping * mapping() const
		{
		switch ( val_case_index() )
			{
			case 1:
			case 2:
			case 3:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:35:mapping", val_case_index(), "PMAPPROC_SET, PMAPPROC_UNSET, PMAPPROC_GETPORT");
				break;
			}
		return mapping_;
		}
	PortmapCallItParams * callit() const
		{
		switch ( val_case_index() )
			{
			case 5:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:37:callit", val_case_index(), "PMAPPROC_CALLIT");
				break;
			}
		return callit_;
		}
	RPC_Call * call() const { return call_; }
	
protected:
	int val_case_index_;
	PortmapMapping * mapping_;
	PortmapCallItParams * callit_;
	RPC_Call * call_;
};


class PortmapResults
{
public:
	PortmapResults(RPC_Call * call);
	~PortmapResults();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSunRPC * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	uint32 set() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:42:set", val_case_index(), "PMAPPROC_SET");
				break;
			}
		return set_;
		}
	uint32 unset() const
		{
		switch ( val_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:43:unset", val_case_index(), "PMAPPROC_UNSET");
				break;
			}
		return unset_;
		}
	uint32 getport() const
		{
		switch ( val_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:44:getport", val_case_index(), "PMAPPROC_GETPORT");
				break;
			}
		return getport_;
		}
	PortmapDumpResults * dump() const
		{
		switch ( val_case_index() )
			{
			case 4:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:45:dump", val_case_index(), "PMAPPROC_DUMP");
				break;
			}
		return dump_;
		}
	PortmapCallItResults * callit() const
		{
		switch ( val_case_index() )
			{
			case 5:
				break;  // OK
			default:
				throw ExceptionInvalidCase("./portmap-protocol.pac:46:callit", val_case_index(), "PMAPPROC_CALLIT");
				break;
			}
		return callit_;
		}
	RPC_Call * call() const { return call_; }
	bool action_reply() const { return action_reply_; }
	
protected:
	int val_case_index_;
	uint32 set_;
	uint32 unset_;
	uint32 getport_;
	PortmapDumpResults * dump_;
	PortmapCallItResults * callit_;
	RPC_Call * call_;
	bool action_reply_;
};


class PortmapMapping
{
public:
	PortmapMapping();
	~PortmapMapping();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 prog() const { return prog_; }
	uint32 vers() const { return vers_; }
	uint32 proto() const { return proto_; }
	uint32 port() const { return port_; }
	
protected:
	uint32 prog_;
	uint32 vers_;
	uint32 proto_;
	uint32 port_;
};


class PortmapCallItParams
{
public:
	PortmapCallItParams();
	~PortmapCallItParams();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 prog() const { return prog_; }
	uint32 vers() const { return vers_; }
	uint32 proc() const { return proc_; }
	RPC_Opaque * params() const { return params_; }
	
protected:
	uint32 prog_;
	uint32 vers_;
	uint32 proc_;
	RPC_Opaque * params_;
};


class PortmapDumpEntry
{
public:
	PortmapDumpEntry();
	~PortmapDumpEntry();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 cont() const { return cont_; }
	int optmapping_case_index() const	{ return optmapping_case_index_; }
	PortmapMapping * mapping() const
		{
		return mapping_;
		}
	
protected:
	uint32 cont_;
	int optmapping_case_index_;
	PortmapMapping * mapping_;
};


class PortmapDumpResults
{
public:
	PortmapDumpResults();
	~PortmapDumpResults();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	vector<PortmapDumpEntry *> * val() const { return val_; }
	int size() const	{ return val() ? val()->size() : 0; }
	PortmapDumpEntry * operator[](int index) const { BINPAC_ASSERT(val()); return (*val())[index]; }
	
protected:
	vector<PortmapDumpEntry *> * val_;
	PortmapDumpEntry * val__elem_;
};


class PortmapCallItResults
{
public:
	PortmapCallItResults();
	~PortmapCallItResults();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 port() const { return port_; }
	RPC_Opaque * results() const { return results_; }
	
protected:
	uint32 port_;
	RPC_Opaque * results_;
};

BroVal PortmapBuildCallVal(RPC_Call * call, PortmapParams * params);
BroPortVal PortmapBuildPortVal(uint32 port, uint32 proto);
BroVal PortmapBuildMappingVal(PortmapMapping * params);
BroVal PortmapBuildPortRequest(PortmapMapping * params);
BroVal PortmapBuildCallItVal(PortmapCallItParams * params);
BroVal PortmapBuildDumpVal(PortmapDumpResults * params);
bool PortmapCallFailed(RPC_Conn * connection, RPC_Call * call, EnumRPCStatus status);
} // namespace SunRPC
}  // namespace binpac
#endif /* __rpc_pac_h */
