// This file is automatically generated from ./ssl-record-layer.pac.

#include "../src/ssl-record-layer_pac.h"

namespace binpac {






namespace SSLRecordLayer {
ContextSSLRecordLayer::ContextSSLRecordLayer(SSLRecordLayerAnalyzer * analyzer, SSLRecordLayerFlow * flow, FlowBuffer * flow_buffer)
	{
	analyzer_ = analyzer;
	flow_ = flow;
	flow_buffer_ = flow_buffer;
	}

ContextSSLRecordLayer::~ContextSSLRecordLayer()
	{
	}


	string* record_type_label(int type)
		{
		switch ( type ) {
		case CHANGE_CIPHER_SPEC:
			return new string("CHANGE_CIPHER_SPEC");
		case ALERT:
			return new string("ALERT");
		case HANDSHAKE:
			return new string("HANDSHAKE");
		case APPLICATION_DATA:
			return new string("APPLICATION_DATA");
		case V2_ERROR:
			return new string("V2_ERROR");
		case V2_CLIENT_HELLO:
			return new string("V2_CLIENT_HELLO");
		case V2_CLIENT_MASTER_KEY:
			return new string("V2_CLIENT_MASTER_KEY");
		case V2_SERVER_HELLO:
			return new string("V2_SERVER_HELLO");
		case UNKNOWN_OR_V2_ENCRYPTED:
			return new string("UNKNOWN_OR_V2_ENCRYPTED");

		default:
			return new string(fmt("UNEXPECTED (%d)", type));
		}
		}

SSLPDU::SSLPDU()
	{
	head0_ = 0;
	head1_ = 0;
	head2_ = 0;
	head3_ = 0;
	head4_ = 0;
	byteorder_ = bigendian;
	buffering_state_ = 0;
	}

SSLPDU::~SSLPDU()
	{
	fragment_.free();
	}

bool SSLPDU::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSLRecordLayer * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(5, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			int t_t_var_001;
			// Checking out-of-bound for "SSLPDU:head4"
			if ( (t_begin_of_data + 4) + (1) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("SSLPDU:head4",
					(4) + (1), 
					(t_end_of_data) - (t_begin_of_data));
				}
			// Parse "head0"
			head0_ = *((uint8 const *) (t_begin_of_data));
			// Evaluate 'let' and 'withinput' fields
			// Parse "head1"
			head1_ = *((uint8 const *) ((t_begin_of_data + 1)));
			// Evaluate 'let' and 'withinput' fields
			// Parse "head2"
			head2_ = *((uint8 const *) ((t_begin_of_data + 2)));
			// Evaluate 'let' and 'withinput' fields
			version_ = t_context->analyzer()->determine_ssl_version(head0(), head1(), head2());
			// Parse "head3"
			head3_ = *((uint8 const *) ((t_begin_of_data + 3)));
			// Evaluate 'let' and 'withinput' fields
			// Parse "head4"
			head4_ = *((uint8 const *) ((t_begin_of_data + 4)));
			// Evaluate 'let' and 'withinput' fields
			switch ( version() )
				{
				case 0:
					t_t_var_001 = 0;
					break;
				case 2:
					t_t_var_001 =  (  (  ( head0() & 0x7f )  << 8 )  | head1() )  - 3;
					break;
				default:
					t_t_var_001 =  ( head3() << 8 )  | head4();
					break;
				}
			length_ = t_t_var_001;
			t_flow_buffer->GrowFrame(5 + length());
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				
				
				
				
				
				// Parse "fragment"
				int t_fragment_string_length;
				t_fragment_string_length = (t_end_of_data) - ((t_begin_of_data + 5));
				int t_fragment__size;
				t_fragment__size = t_fragment_string_length;
				// check for negative sizes
				if ( t_fragment_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-record-layer.pac:32", t_fragment_string_length);
				fragment_.init((t_begin_of_data + 5), t_fragment_string_length);
				// Evaluate 'let' and 'withinput' fields
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					int t_t_var_002;
					switch ( version() )
						{
						case 0:
							t_t_var_002 = t_context->analyzer()->forward_record(const_bytestring(), UNKNOWN_OR_V2_ENCRYPTED, UNKNOWN_VERSION, t_context->flow()->is_orig()) && t_context->flow()->discard_data();
							break;
						case 2:
							t_t_var_002 = t_context->analyzer()->forward_v2_record(head2(), head3(), head4(), fragment(), t_context->flow()->is_orig());
							break;
						default:
							t_t_var_002 = t_context->analyzer()->forward_record(fragment(), head0(),  ( head1() << 8 )  | head2(), t_context->flow()->is_orig());
							break;
						}
					fw_ = t_t_var_002;
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

SSLRecordLayerAnalyzer::SSLRecordLayerAnalyzer()
	{
	upflow_ = new SSLRecordLayerFlow(this, true);
	downflow_ = new SSLRecordLayerFlow(this, false);

		ssl_analyzer_ = 0;
		ssl_version_ = UNKNOWN_VERSION;
		record_length_ = 0;
	
	}

SSLRecordLayerAnalyzer::~SSLRecordLayerAnalyzer()
	{
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void SSLRecordLayerAnalyzer::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void SSLRecordLayerAnalyzer::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void SSLRecordLayerAnalyzer::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();

		ssl_analyzer_->FlowEOF(true);
		ssl_analyzer_->FlowEOF(false);
	
	}

void SSLRecordLayerAnalyzer::set_ssl_analyzer(SSLAnalyzer * a)
	{
 ssl_analyzer_ = a; 
	}

int SSLRecordLayerAnalyzer::ssl_version()
	{
 return ssl_version_; 
	}

int SSLRecordLayerAnalyzer::record_length()
	{
 return record_length_; 
	}

int SSLRecordLayerAnalyzer::determine_ssl_version(uint8 head0, uint8 head1, uint8 head2)
	{

		if ( head0 >= 20 && head0 <= 23 &&
		     head1 == 0x03 && head2 <  0x03 )
			// This is most probably SSL version 3.
			ssl_version_ = (head1 << 8) | head2;

		else if ( head0 >= 128 && head2 < 5 && head2 != 3 )
			// Not very strong evidence, but we suspect
			// this to be SSLv2.
			ssl_version_ = SSLv20;

		else
			ssl_version_ = UNKNOWN_VERSION;

		return ssl_version_;
		
	}

bool SSLRecordLayerAnalyzer::forward_record(const_bytestring const & fragment, int type, uint16 version, bool is_orig)
	{

		return ssl_analyzer_->next_record(fragment, type,
							version, is_orig);
		
	}

bool SSLRecordLayerAnalyzer::forward_v2_record(uint8 b1, uint8 b2, uint8 b3, const_bytestring const & fragment, bool is_orig)
	{

		uint8* buffer = new uint8[2 + fragment.length()];

		// Byte 1 is the record type.
		buffer[0] = b2;
		buffer[1] = b3;

		memcpy(buffer + 2, fragment.begin(), fragment.length());
		const_bytestring bs(buffer, 2 + fragment.length());

		bool ret = ssl_analyzer_->next_record(bs, 300 + b1, SSLv20,
							is_orig);
		delete [] buffer;
		return ret;
		
	}

SSLRecordLayerFlow::SSLRecordLayerFlow(SSLRecordLayerAnalyzer * connection, bool is_orig)
	{
	flow_buffer_ = 0;
	connection_ = connection;
	is_orig_ = is_orig;
	dataunit_ = 0;
	context_ = 0;
	flow_buffer_ = new FlowBuffer();
	}

SSLRecordLayerFlow::~SSLRecordLayerFlow()
	{
	delete dataunit_;
	dataunit_ = 0;
	delete context_;
	context_ = 0;
	delete flow_buffer_;
	flow_buffer_ = 0;
	}

void SSLRecordLayerFlow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		flow_buffer_->NewData(t_begin_of_data, t_end_of_data);
		while ( flow_buffer_->data_available() && 
			( !flow_buffer_->have_pending_request() || flow_buffer_->ready() ) )
			{
			if ( ! dataunit_ )
				{
				BINPAC_ASSERT(!context_);
				dataunit_ = new SSLPDU();
				flow_buffer_->NewFrame(0, false);
				context_ = new ContextSSLRecordLayer(connection(), this, flow_buffer_);
				}
			bool t_dataunit_parsing_complete;
			t_dataunit_parsing_complete = false;
			while ( ! t_dataunit_parsing_complete && flow_buffer_->ready() )
				{
				const_byteptr t_begin_of_data = flow_buffer_->begin();
				const_byteptr t_end_of_data = flow_buffer_->end();
				t_dataunit_parsing_complete = dataunit_->ParseBuffer(flow_buffer_, context_);
				if ( t_dataunit_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			if ( t_dataunit_parsing_complete )
				{
				// Clean up the flow unit after parsing
				delete dataunit_;
				dataunit_ = 0;
				delete context_;
				context_ = 0;
				}
			else
				{
				// Resume upon next input segment
				BINPAC_ASSERT(!flow_buffer_->ready());
				break;
				}
			}
		}
	catch ( Exception const &e )
		{
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		flow_buffer_->DiscardData();
		throw e;
		}
	}

void SSLRecordLayerFlow::NewGap(int gap_length)
	{
	flow_buffer_->NewGap(gap_length);
	}
void SSLRecordLayerFlow::FlowEOF()
	{
	flow_buffer_->set_eof();
	NewData(0, 0);
	}
bool SSLRecordLayerFlow::discard_data()
	{

		flow_buffer_->DiscardData();
		return true;
		
	}

} // namespace SSLRecordLayer
}  // namespace binpac
