// This file is automatically generated from ./ssl.pac.

#include "../src/ssl_pac.h"

namespace binpac {






namespace SSL {
ContextSSL::ContextSSL(SSLAnalyzer * analyzer, SSLFlow * flow, FlowBuffer * flow_buffer)
	{
	analyzer_ = analyzer;
	flow_ = flow;
	flow_buffer_ = flow_buffer;
	}

ContextSSL::~ContextSSL()
	{
	}


	string* record_type_label(int type)
		{
		switch ( type ) {
		case CHANGE_CIPHER_SPEC:
			return new string("CHANGE_CIPHER_SPEC");
		case ALERT:
			return new string("ALERT");
		case HANDSHAKE:
			return new string("HANDSHAKE");
		case APPLICATION_DATA:
			return new string("APPLICATION_DATA");
		case V2_ERROR:
			return new string("V2_ERROR");
		case V2_CLIENT_HELLO:
			return new string("V2_CLIENT_HELLO");
		case V2_CLIENT_MASTER_KEY:
			return new string("V2_CLIENT_MASTER_KEY");
		case V2_SERVER_HELLO:
			return new string("V2_SERVER_HELLO");
		case UNKNOWN_OR_V2_ENCRYPTED:
			return new string("UNKNOWN_OR_V2_ENCRYPTED");

		default:
			return new string(fmt("UNEXPECTED (%d)", type));
		}
		}

uint24::uint24()
	{
	byte1_ = 0;
	byte2_ = 0;
	byte3_ = 0;
	}

uint24::~uint24()
	{
	}

int uint24::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "uint24"
	if ( t_begin_of_data + (3) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("uint24",
			(0) + (3), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte1"
	byte1_ = *((uint8 const *) (t_begin_of_data));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "byte2"
	byte2_ = *((uint8 const *) ((t_begin_of_data + 1)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "byte3"
	byte3_ = *((uint8 const *) ((t_begin_of_data + 2)));
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (3) <= t_end_of_data);
	return 3;
	}


	string state_label(int state_nr)
		{
		switch ( state_nr ) {
		case STATE_INITIAL:
			return string("INITIAL");
		case STATE_CLIENT_HELLO_RCVD:
			return string("CLIENT_HELLO_RCVD");
		case STATE_IN_SERVER_HELLO:
			return string("IN_SERVER_HELLO");
		case STATE_SERVER_HELLO_DONE:
			return string("SERVER_HELLO_DONE");
		case STATE_CLIENT_CERT:
			return string("CLIENT_CERT");
		case STATE_CLIENT_KEY_WITH_CERT:
			return string("CLIENT_KEY_WITH_CERT");
		case STATE_CLIENT_KEY_NO_CERT:
			return string("CLIENT_KEY_NO_CERT");
		case STATE_CLIENT_CERT_VERIFIED:
			return string("CLIENT_CERT_VERIFIED");
		case STATE_CLIENT_ENCRYPTED:
			return string("CLIENT_ENCRYPTED");
		case STATE_CLIENT_FINISHED:
			return string("CLIENT_FINISHED");
		case STATE_ABBREV_SERVER_ENCRYPTED:
			return string("ABBREV_SERVER_ENCRYPTED");
		case STATE_ABBREV_SERVER_FINISHED:
			return string("ABBREV_SERVER_FINISHED");
		case STATE_COMM_ENCRYPTED:
			return string("COMM_ENCRYPTED");
		case STATE_CONN_ESTABLISHED:
			return string("CONN_ESTABLISHED");
		case STATE_V2_CL_MASTER_KEY_EXPECTED:
			return string("STATE_V2_CL_MASTER_KEY_EXPECTED");
		case STATE_TRACK_LOST:
			return string("TRACK_LOST");
		case STATE_ANY:
			return string("ANY");

		default:
			return string(fmt("UNKNOWN (%d)", state_nr));
		}
		}

	string orig_label(bool is_orig)
		{
		return string(is_orig ? "originator" :"responder");
		}


	string handshake_type_label(int type)
		{
		switch ( type ) {
		case HELLO_REQUEST: return string("HELLO_REQUEST");
		case CLIENT_HELLO: return string("CLIENT_HELLO");
		case SERVER_HELLO: return string("SERVER_HELLO");
		case CERTIFICATE: return string("CERTIFICATE");
		case SERVER_KEY_EXCHANGE: return string("SERVER_KEY_EXCHANGE");
		case CERTIFICATE_REQUEST: return string("CERTIFICATE_REQUEST");
		case SERVER_HELLO_DONE: return string("SERVER_HELLO_DONE");
		case CERTIFICATE_VERIFY: return string("CERTIFICATE_VERIFY");
		case CLIENT_KEY_EXCHANGE: return string("CLIENT_KEY_EXCHANGE");
		case FINISHED: return string("FINISHED");
		default: return string(fmt("UNKNOWN (%d)", type));
		}
		}

ChangeCipherSpec::ChangeCipherSpec()
	{
	type_ = 0;
	buffering_state_ = 0;
	}

ChangeCipherSpec::~ChangeCipherSpec()
	{
	}

bool ChangeCipherSpec::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(0, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			t_flow_buffer->GrowFrame(1);
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Checking out-of-bound for "ChangeCipherSpec:type"
				if ( t_begin_of_data + (1) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("ChangeCipherSpec:type",
						(0) + (1), 
						(t_end_of_data) - (t_begin_of_data));
					}
				// Parse "type"
				type_ = *((uint8 const *) (t_begin_of_data));
				// Evaluate 'let' and 'withinput' fields
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					state_changed_ = t_context->analyzer()->transition(STATE_CLIENT_FINISHED, STATE_COMM_ENCRYPTED, false) || t_context->analyzer()->transition(STATE_IN_SERVER_HELLO, STATE_ABBREV_SERVER_ENCRYPTED, false) || t_context->analyzer()->transition(STATE_CLIENT_KEY_NO_CERT, STATE_CLIENT_ENCRYPTED, true) || t_context->analyzer()->transition(STATE_CLIENT_CERT_VERIFIED, STATE_CLIENT_ENCRYPTED, true) || t_context->analyzer()->transition(STATE_CLIENT_KEY_WITH_CERT, STATE_CLIENT_ENCRYPTED, true) || t_context->analyzer()->transition(STATE_ABBREV_SERVER_FINISHED, STATE_COMM_ENCRYPTED, true) || t_context->analyzer()->lost_track();
					proc_ = t_context->analyzer()->proc_change_cipher_spec(this);
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

Alert::Alert()
	{
	level_ = 0;
	description_ = 0;
	buffering_state_ = 0;
	}

Alert::~Alert()
	{
	}

bool Alert::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(0, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			t_flow_buffer->GrowFrame(2);
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Checking out-of-bound for "Alert:description"
				if ( (t_begin_of_data + 1) + (1) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("Alert:description",
						(1) + (1), 
						(t_end_of_data) - (t_begin_of_data));
					}
				// Parse "level"
				level_ = *((uint8 const *) (t_begin_of_data));
				// Evaluate 'let' and 'withinput' fields
				
				// Parse "description"
				description_ = *((uint8 const *) ((t_begin_of_data + 1)));
				// Evaluate 'let' and 'withinput' fields
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					proc_ = t_context->analyzer()->proc_alert(level(), description());
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

V2Error::V2Error()
	{
	error_code_ = 0;
	buffering_state_ = 0;
	}

V2Error::~V2Error()
	{
	}

bool V2Error::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(0, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			t_flow_buffer->GrowFrame(2);
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Checking out-of-bound for "V2Error:error_code"
				if ( t_begin_of_data + (2) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2Error:error_code",
						(0) + (2), 
						(t_end_of_data) - (t_begin_of_data));
					}
				// Parse "error_code"
				error_code_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_begin_of_data)));
				// Evaluate 'let' and 'withinput' fields
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					proc_ = t_context->analyzer()->proc_alert(-1, error_code());
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

ApplicationData::ApplicationData()
	{
	}

ApplicationData::~ApplicationData()
	{
	}

int ApplicationData::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Evaluate 'let' and 'withinput' fields
	discard_ = t_context->flow()->discard_data();
	proc_ = t_context->analyzer()->proc_application_data(this);
	BINPAC_ASSERT(t_begin_of_data + (0) <= t_end_of_data);
	return 0;
	}

HelloRequest::HelloRequest()
	{
	}

HelloRequest::~HelloRequest()
	{
	}

int HelloRequest::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Evaluate 'let' and 'withinput' fields
	hr_ = t_context->analyzer()->set_hello_requested(true);
	BINPAC_ASSERT(t_begin_of_data + (0) <= t_end_of_data);
	return 0;
	}

ClientHello::ClientHello()
	{
	client_version_ = 0;
	gmt_unix_time_ = 0;
	session_len_ = 0;
	session_id_ = 0;
	session_id__elem_ = 0;
	csuit_len_ = 0;
	csuits_ = 0;
	csuits__elem_ = 0;
	cmeth_len_ = 0;
	cmeths_ = 0;
	cmeths__elem_ = 0;
	}

ClientHello::~ClientHello()
	{
	delete session_id_;
	delete csuits_;
	delete cmeths_;
	}

int ClientHello::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context, int t_byteorder)
	{
	// Checking out-of-bound for "ClientHello:gmt_unix_time"
	if ( (t_begin_of_data + 2) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ClientHello:gmt_unix_time",
			(2) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "client_version"
	client_version_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "gmt_unix_time"
	gmt_unix_time_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 2))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "random_bytes"
	// Checking out-of-bound for "ClientHello:random_bytes"
	if ( (t_begin_of_data + 6) + (28) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ClientHello:random_bytes",
			(6) + (28), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = (t_begin_of_data + 6) + 28;
	int t_random_bytes_string_length;
	t_random_bytes_string_length = 28;
	int t_random_bytes__size;
	t_random_bytes__size = t_random_bytes_string_length;
	// check for negative sizes
	if ( t_random_bytes_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:215", t_random_bytes_string_length);
	random_bytes_.init((t_begin_of_data + 6), t_random_bytes_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	const_byteptr const t_dataptr_after_random_bytes = (t_begin_of_data + 6) + (28);
	BINPAC_ASSERT(t_dataptr_after_random_bytes <= t_end_of_data);
	// Checking out-of-bound for "ClientHello:session_len"
	if ( t_dataptr_after_random_bytes + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ClientHello:session_len",
			((t_dataptr_after_random_bytes - t_begin_of_data)) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "session_len"
	session_len_ = *((uint8 const *) (t_dataptr_after_random_bytes));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "session_id"
	int t_session_id__arraylength;
	t_session_id__arraylength = session_len();
	if ( t_begin_of_data + t_session_id__arraylength > t_end_of_data + 1 )
		{
		t_session_id__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_session_id__arraylength < 0 )
		{
		t_session_id__arraylength = 0;
		}
	session_id__elem_ = 0;
	int t_session_id__elem__it;
	t_session_id__elem__it = 0;
	int t_session_id__size;
	session_id_ = new vector<uint8>;
	session_id_->reserve(t_session_id__arraylength);
	const_byteptr t_session_id__elem__dataptr = (t_dataptr_after_random_bytes + 1);
	for (; t_session_id__elem__it < t_session_id__arraylength; ++t_session_id__elem__it)
		{
		// Check &until(session_id__elem__dataptr >= end_of_data)
		if ( t_session_id__elem__dataptr >= t_end_of_data )
			{
			goto end_of_session_id;
			}
		// Checking out-of-bound for "ClientHello:session_id__elem"
		if ( t_session_id__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("ClientHello:session_id__elem",
				((t_session_id__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		session_id__elem_ = *((uint8 const *) (t_session_id__elem__dataptr));
		// Evaluate 'let' and 'withinput' fields
		session_id_->push_back(session_id__elem_);
		t_session_id__elem__dataptr += 1;
		BINPAC_ASSERT(t_session_id__elem__dataptr <= t_end_of_data);
		}
end_of_session_id: ;
	t_session_id__size = t_session_id__elem__dataptr - ((t_dataptr_after_random_bytes + 1));
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_session_id = (t_dataptr_after_random_bytes + 1) + (t_session_id__size);
	BINPAC_ASSERT(t_dataptr_after_session_id <= t_end_of_data);
	// Checking out-of-bound for "ClientHello:csuit_len"
	if ( t_dataptr_after_session_id + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ClientHello:csuit_len",
			((t_dataptr_after_session_id - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "csuit_len"
	csuit_len_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_dataptr_after_session_id)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "csuits"
	int t_csuits__arraylength;
	t_csuits__arraylength = csuit_len() / 2;
	if ( t_begin_of_data + t_csuits__arraylength > t_end_of_data + 1 )
		{
		t_csuits__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_csuits__arraylength < 0 )
		{
		t_csuits__arraylength = 0;
		}
	csuits__elem_ = 0;
	int t_csuits__elem__it;
	t_csuits__elem__it = 0;
	int t_csuits__size;
	csuits_ = new vector<uint16>;
	csuits_->reserve(t_csuits__arraylength);
	const_byteptr t_csuits__elem__dataptr = (t_dataptr_after_session_id + 2);
	for (; t_csuits__elem__it < t_csuits__arraylength; ++t_csuits__elem__it)
		{
		// Check &until(csuits__elem__dataptr >= end_of_data)
		if ( t_csuits__elem__dataptr >= t_end_of_data )
			{
			goto end_of_csuits;
			}
		// Checking out-of-bound for "ClientHello:csuits__elem"
		if ( t_csuits__elem__dataptr + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("ClientHello:csuits__elem",
				((t_csuits__elem__dataptr - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		csuits__elem_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_csuits__elem__dataptr)));
		// Evaluate 'let' and 'withinput' fields
		csuits_->push_back(csuits__elem_);
		t_csuits__elem__dataptr += 2;
		BINPAC_ASSERT(t_csuits__elem__dataptr <= t_end_of_data);
		}
end_of_csuits: ;
	t_csuits__size = t_csuits__elem__dataptr - ((t_dataptr_after_session_id + 2));
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_csuits = (t_dataptr_after_session_id + 2) + (t_csuits__size);
	BINPAC_ASSERT(t_dataptr_after_csuits <= t_end_of_data);
	// Checking out-of-bound for "ClientHello:cmeth_len"
	if ( t_dataptr_after_csuits + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ClientHello:cmeth_len",
			((t_dataptr_after_csuits - t_begin_of_data)) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "cmeth_len"
	cmeth_len_ = *((uint8 const *) (t_dataptr_after_csuits));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "cmeths"
	int t_cmeths__arraylength;
	t_cmeths__arraylength = cmeth_len();
	if ( t_begin_of_data + t_cmeths__arraylength > t_end_of_data + 1 )
		{
		t_cmeths__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_cmeths__arraylength < 0 )
		{
		t_cmeths__arraylength = 0;
		}
	cmeths__elem_ = 0;
	int t_cmeths__elem__it;
	t_cmeths__elem__it = 0;
	int t_cmeths__size;
	cmeths_ = new vector<uint8>;
	cmeths_->reserve(t_cmeths__arraylength);
	const_byteptr t_cmeths__elem__dataptr = (t_dataptr_after_csuits + 1);
	for (; t_cmeths__elem__it < t_cmeths__arraylength; ++t_cmeths__elem__it)
		{
		// Check &until(cmeths__elem__dataptr >= end_of_data)
		if ( t_cmeths__elem__dataptr >= t_end_of_data )
			{
			goto end_of_cmeths;
			}
		// Checking out-of-bound for "ClientHello:cmeths__elem"
		if ( t_cmeths__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("ClientHello:cmeths__elem",
				((t_cmeths__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		cmeths__elem_ = *((uint8 const *) (t_cmeths__elem__dataptr));
		// Evaluate 'let' and 'withinput' fields
		cmeths_->push_back(cmeths__elem_);
		t_cmeths__elem__dataptr += 1;
		BINPAC_ASSERT(t_cmeths__elem__dataptr <= t_end_of_data);
		}
end_of_cmeths: ;
	t_cmeths__size = t_cmeths__elem__dataptr - ((t_dataptr_after_csuits + 1));
	// Evaluate 'let' and 'withinput' fields
	
	int t_ClientHello__size;
	const_byteptr const t_dataptr_after_cmeths = (t_dataptr_after_csuits + 1) + (t_cmeths__size);
	BINPAC_ASSERT(t_dataptr_after_cmeths <= t_end_of_data);
	t_ClientHello__size = t_dataptr_after_cmeths - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_INITIAL, STATE_CLIENT_HELLO_RCVD, true) ||  ( t_context->analyzer()->hello_requested() && t_context->analyzer()->transition(STATE_ANY, STATE_CLIENT_HELLO_RCVD, true) )  || t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_client_hello(client_version(), session_id(), convert_ciphers_uint16(csuits()));
	BINPAC_ASSERT(t_begin_of_data + (t_ClientHello__size) <= t_end_of_data);
	return t_ClientHello__size;
	}

V2ClientHello::V2ClientHello()
	{
	client_version_ = 0;
	csuit_len_ = 0;
	session_len_ = 0;
	chal_len_ = 0;
	ciphers_ = 0;
	ciphers__elem_ = 0;
	session_id_ = 0;
	session_id__elem_ = 0;
	buffering_state_ = 0;
	}

V2ClientHello::~V2ClientHello()
	{
	delete ciphers__elem_;
	ciphers__elem_ = 0;
	if ( ciphers() )
		{
		for ( int i = 0; i < (int) ciphers()->size(); ++i )
			{
			uint24 * ciphers__elem_ = (*ciphers_)[i];
			delete ciphers__elem_;
			ciphers__elem_ = 0;
			}
		}
	delete ciphers_;
	delete session_id_;
	challenge_.free();
	}

bool V2ClientHello::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(8, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			// Checking out-of-bound for "V2ClientHello:chal_len"
			if ( (t_begin_of_data + 6) + (2) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("V2ClientHello:chal_len",
					(6) + (2), 
					(t_end_of_data) - (t_begin_of_data));
				}
			// Parse "csuit_len"
			csuit_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "session_len"
			session_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 4))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "chal_len"
			chal_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 6))));
			// Evaluate 'let' and 'withinput' fields
			t_flow_buffer->GrowFrame(8 + csuit_len() + session_len() + chal_len());
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Parse "client_version"
				client_version_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_begin_of_data)));
				// Evaluate 'let' and 'withinput' fields
				
				
				
				
				// Parse "ciphers"
				int t_ciphers__arraylength;
				t_ciphers__arraylength = csuit_len() / 3;
				if ( t_begin_of_data + t_ciphers__arraylength > t_end_of_data + 1 )
					{
					t_ciphers__arraylength = t_end_of_data - t_begin_of_data + 1;
					}
				if ( t_ciphers__arraylength < 0 )
					{
					t_ciphers__arraylength = 0;
					}
				ciphers__elem_ = 0;
				int t_ciphers__elem__it;
				t_ciphers__elem__it = 0;
				int t_ciphers__size;
				ciphers_ = new vector<uint24 *>;
				ciphers_->reserve(t_ciphers__arraylength);
				const_byteptr t_ciphers__elem__dataptr = (t_begin_of_data + 8);
				for (; t_ciphers__elem__it < t_ciphers__arraylength; ++t_ciphers__elem__it)
					{
					// Check &until(ciphers__elem__dataptr >= end_of_data)
					if ( t_ciphers__elem__dataptr >= t_end_of_data )
						{
						ciphers__elem_ = 0;
						goto end_of_ciphers;
						}
					ciphers__elem_ = new uint24();
					ciphers__elem_->Parse(t_ciphers__elem__dataptr, t_end_of_data);
					// Evaluate 'let' and 'withinput' fields
					ciphers_->push_back(ciphers__elem_);
					t_ciphers__elem__dataptr += 3;
					BINPAC_ASSERT(t_ciphers__elem__dataptr <= t_end_of_data);
					ciphers__elem_ = 0;
					}
			end_of_ciphers: ;
				t_ciphers__size = t_ciphers__elem__dataptr - ((t_begin_of_data + 8));
				// Evaluate 'let' and 'withinput' fields
				
				const_byteptr const t_dataptr_after_ciphers = (t_begin_of_data + 8) + (t_ciphers__size);
				BINPAC_ASSERT(t_dataptr_after_ciphers <= t_end_of_data);
				// Parse "session_id"
				int t_session_id__arraylength;
				t_session_id__arraylength = session_len();
				if ( t_begin_of_data + t_session_id__arraylength > t_end_of_data + 1 )
					{
					t_session_id__arraylength = t_end_of_data - t_begin_of_data + 1;
					}
				if ( t_session_id__arraylength < 0 )
					{
					t_session_id__arraylength = 0;
					}
				session_id__elem_ = 0;
				int t_session_id__elem__it;
				t_session_id__elem__it = 0;
				int t_session_id__size;
				session_id_ = new vector<uint8>;
				session_id_->reserve(t_session_id__arraylength);
				const_byteptr t_session_id__elem__dataptr = t_dataptr_after_ciphers;
				for (; t_session_id__elem__it < t_session_id__arraylength; ++t_session_id__elem__it)
					{
					// Check &until(session_id__elem__dataptr >= end_of_data)
					if ( t_session_id__elem__dataptr >= t_end_of_data )
						{
						goto end_of_session_id;
						}
					// Checking out-of-bound for "V2ClientHello:session_id__elem"
					if ( t_session_id__elem__dataptr + (1) > t_end_of_data )
						{
						// Handle out-of-bound condition
						throw ExceptionOutOfBound("V2ClientHello:session_id__elem",
							((t_session_id__elem__dataptr - t_begin_of_data)) + (1), 
							(t_end_of_data) - (t_begin_of_data));
						}
					session_id__elem_ = *((uint8 const *) (t_session_id__elem__dataptr));
					// Evaluate 'let' and 'withinput' fields
					session_id_->push_back(session_id__elem_);
					t_session_id__elem__dataptr += 1;
					BINPAC_ASSERT(t_session_id__elem__dataptr <= t_end_of_data);
					}
			end_of_session_id: ;
				t_session_id__size = t_session_id__elem__dataptr - (t_dataptr_after_ciphers);
				// Evaluate 'let' and 'withinput' fields
				
				const_byteptr const t_dataptr_after_session_id = t_dataptr_after_ciphers + (t_session_id__size);
				BINPAC_ASSERT(t_dataptr_after_session_id <= t_end_of_data);
				// Parse "challenge"
				int t_challenge__size;
				t_challenge__size = chal_len();
				// Checking out-of-bound for "V2ClientHello:challenge"
				if ( t_dataptr_after_session_id + (t_challenge__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ClientHello:challenge",
						((t_dataptr_after_session_id - t_begin_of_data)) + (t_challenge__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = t_dataptr_after_session_id + t_challenge__size;
				int t_challenge_string_length;
				t_challenge_string_length = chal_len();
				// check for negative sizes
				if ( t_challenge_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:243", t_challenge_string_length);
				challenge_.init(t_dataptr_after_session_id, t_challenge_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					state_changed_ = t_context->analyzer()->transition(STATE_INITIAL, STATE_CLIENT_HELLO_RCVD, true) ||  ( t_context->analyzer()->hello_requested() && t_context->analyzer()->transition(STATE_ANY, STATE_CLIENT_HELLO_RCVD, true) )  || t_context->analyzer()->lost_track();
					proc_ = t_context->analyzer()->proc_client_hello(client_version(), session_id(), convert_ciphers_uint24(ciphers()));
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

ServerHello::ServerHello()
	{
	server_version_ = 0;
	gmt_unix_time_ = 0;
	session_len_ = 0;
	session_id_ = 0;
	session_id__elem_ = 0;
	cipher_suite_ = 0;
	cipher_suite__elem_ = 0;
	compression_method_ = 0;
	}

ServerHello::~ServerHello()
	{
	delete session_id_;
	delete cipher_suite_;
	}

int ServerHello::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context, int t_byteorder)
	{
	// Checking out-of-bound for "ServerHello:gmt_unix_time"
	if ( (t_begin_of_data + 2) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ServerHello:gmt_unix_time",
			(2) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "server_version"
	server_version_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "gmt_unix_time"
	gmt_unix_time_ = FixByteOrder(t_byteorder, *((uint32 const *) ((t_begin_of_data + 2))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "random_bytes"
	// Checking out-of-bound for "ServerHello:random_bytes"
	if ( (t_begin_of_data + 6) + (28) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ServerHello:random_bytes",
			(6) + (28), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = (t_begin_of_data + 6) + 28;
	int t_random_bytes_string_length;
	t_random_bytes_string_length = 28;
	int t_random_bytes__size;
	t_random_bytes__size = t_random_bytes_string_length;
	// check for negative sizes
	if ( t_random_bytes_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:261", t_random_bytes_string_length);
	random_bytes_.init((t_begin_of_data + 6), t_random_bytes_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	const_byteptr const t_dataptr_after_random_bytes = (t_begin_of_data + 6) + (28);
	BINPAC_ASSERT(t_dataptr_after_random_bytes <= t_end_of_data);
	// Checking out-of-bound for "ServerHello:session_len"
	if ( t_dataptr_after_random_bytes + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ServerHello:session_len",
			((t_dataptr_after_random_bytes - t_begin_of_data)) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "session_len"
	session_len_ = *((uint8 const *) (t_dataptr_after_random_bytes));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "session_id"
	int t_session_id__arraylength;
	t_session_id__arraylength = session_len();
	if ( t_begin_of_data + t_session_id__arraylength > t_end_of_data + 1 )
		{
		t_session_id__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_session_id__arraylength < 0 )
		{
		t_session_id__arraylength = 0;
		}
	session_id__elem_ = 0;
	int t_session_id__elem__it;
	t_session_id__elem__it = 0;
	int t_session_id__size;
	session_id_ = new vector<uint8>;
	session_id_->reserve(t_session_id__arraylength);
	const_byteptr t_session_id__elem__dataptr = (t_dataptr_after_random_bytes + 1);
	for (; t_session_id__elem__it < t_session_id__arraylength; ++t_session_id__elem__it)
		{
		// Check &until(session_id__elem__dataptr >= end_of_data)
		if ( t_session_id__elem__dataptr >= t_end_of_data )
			{
			goto end_of_session_id;
			}
		// Checking out-of-bound for "ServerHello:session_id__elem"
		if ( t_session_id__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("ServerHello:session_id__elem",
				((t_session_id__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		session_id__elem_ = *((uint8 const *) (t_session_id__elem__dataptr));
		// Evaluate 'let' and 'withinput' fields
		session_id_->push_back(session_id__elem_);
		t_session_id__elem__dataptr += 1;
		BINPAC_ASSERT(t_session_id__elem__dataptr <= t_end_of_data);
		}
end_of_session_id: ;
	t_session_id__size = t_session_id__elem__dataptr - ((t_dataptr_after_random_bytes + 1));
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_session_id = (t_dataptr_after_random_bytes + 1) + (t_session_id__size);
	BINPAC_ASSERT(t_dataptr_after_session_id <= t_end_of_data);
	// Checking out-of-bound for "ServerHello:compression_method"
	if ( (t_dataptr_after_session_id + 2) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ServerHello:compression_method",
			(((t_dataptr_after_session_id + 2) - t_begin_of_data)) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "cipher_suite"
	int t_cipher_suite__arraylength;
	t_cipher_suite__arraylength = 1;
	if ( t_begin_of_data + t_cipher_suite__arraylength > t_end_of_data + 1 )
		{
		t_cipher_suite__arraylength = t_end_of_data - t_begin_of_data + 1;
		}
	if ( t_cipher_suite__arraylength < 0 )
		{
		t_cipher_suite__arraylength = 0;
		}
	cipher_suite__elem_ = 0;
	int t_cipher_suite__elem__it;
	t_cipher_suite__elem__it = 0;
	cipher_suite_ = new vector<uint16>;
	cipher_suite_->reserve(t_cipher_suite__arraylength);
	const_byteptr t_cipher_suite__elem__dataptr = t_dataptr_after_session_id;
	for (; t_cipher_suite__elem__it < t_cipher_suite__arraylength; ++t_cipher_suite__elem__it)
		{
		// Check &until(cipher_suite__elem__dataptr >= end_of_data)
		if ( t_cipher_suite__elem__dataptr >= t_end_of_data )
			{
			goto end_of_cipher_suite;
			}
		cipher_suite__elem_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_cipher_suite__elem__dataptr)));
		// Evaluate 'let' and 'withinput' fields
		cipher_suite_->push_back(cipher_suite__elem_);
		t_cipher_suite__elem__dataptr += 2;
		BINPAC_ASSERT(t_cipher_suite__elem__dataptr <= t_end_of_data);
		}
end_of_cipher_suite: ;
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "compression_method"
	compression_method_ = *((uint8 const *) ((t_dataptr_after_session_id + 2)));
	// Evaluate 'let' and 'withinput' fields
	
	int t_ServerHello__size;
	t_ServerHello__size = (t_dataptr_after_session_id + 3) - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_CLIENT_HELLO_RCVD, STATE_IN_SERVER_HELLO, false) || t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_server_hello(server_version(), session_id(), convert_ciphers_uint16(cipher_suite()), -1);
	BINPAC_ASSERT(t_begin_of_data + (t_ServerHello__size) <= t_end_of_data);
	return t_ServerHello__size;
	}

V2ServerHello::V2ServerHello()
	{
	session_id_hit_ = 0;
	cert_type_ = 0;
	server_version_ = 0;
	cert_len_ = 0;
	ciph_len_ = 0;
	conn_id_len_ = 0;
	ciphers_ = 0;
	ciphers__elem_ = 0;
	buffering_state_ = 0;
	}

V2ServerHello::~V2ServerHello()
	{
	cert_data_.free();
	delete ciphers__elem_;
	ciphers__elem_ = 0;
	if ( ciphers() )
		{
		for ( int i = 0; i < (int) ciphers()->size(); ++i )
			{
			uint24 * ciphers__elem_ = (*ciphers_)[i];
			delete ciphers__elem_;
			ciphers__elem_ = 0;
			}
		}
	delete ciphers_;
	conn_id_data_.free();
	}

bool V2ServerHello::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(10, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			// Checking out-of-bound for "V2ServerHello:conn_id_len"
			if ( (t_begin_of_data + 8) + (2) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("V2ServerHello:conn_id_len",
					(8) + (2), 
					(t_end_of_data) - (t_begin_of_data));
				}
			// Parse "cert_len"
			cert_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 4))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "ciph_len"
			ciph_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 6))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "conn_id_len"
			conn_id_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 8))));
			// Evaluate 'let' and 'withinput' fields
			t_flow_buffer->GrowFrame(10 + cert_len() + ciph_len() + conn_id_len());
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Parse "session_id_hit"
				session_id_hit_ = *((uint8 const *) (t_begin_of_data));
				// Evaluate 'let' and 'withinput' fields
				
				// Parse "cert_type"
				cert_type_ = *((uint8 const *) ((t_begin_of_data + 1)));
				// Evaluate 'let' and 'withinput' fields
				
				// Parse "server_version"
				server_version_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
				// Evaluate 'let' and 'withinput' fields
				
				
				
				
				// Parse "cert_data"
				int t_cert_data__size;
				t_cert_data__size = cert_len();
				// Checking out-of-bound for "V2ServerHello:cert_data"
				if ( (t_begin_of_data + 10) + (t_cert_data__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ServerHello:cert_data",
						(10) + (t_cert_data__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = (t_begin_of_data + 10) + t_cert_data__size;
				int t_cert_data_string_length;
				t_cert_data_string_length = cert_len();
				// check for negative sizes
				if ( t_cert_data_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:285", t_cert_data_string_length);
				cert_data_.init((t_begin_of_data + 10), t_cert_data_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				const_byteptr const t_dataptr_after_cert_data = (t_begin_of_data + 10) + (t_cert_data__size);
				BINPAC_ASSERT(t_dataptr_after_cert_data <= t_end_of_data);
				// Parse "ciphers"
				int t_ciphers__arraylength;
				t_ciphers__arraylength = ciph_len() / 3;
				if ( t_begin_of_data + t_ciphers__arraylength > t_end_of_data + 1 )
					{
					t_ciphers__arraylength = t_end_of_data - t_begin_of_data + 1;
					}
				if ( t_ciphers__arraylength < 0 )
					{
					t_ciphers__arraylength = 0;
					}
				ciphers__elem_ = 0;
				int t_ciphers__elem__it;
				t_ciphers__elem__it = 0;
				int t_ciphers__size;
				ciphers_ = new vector<uint24 *>;
				ciphers_->reserve(t_ciphers__arraylength);
				const_byteptr t_ciphers__elem__dataptr = t_dataptr_after_cert_data;
				for (; t_ciphers__elem__it < t_ciphers__arraylength; ++t_ciphers__elem__it)
					{
					// Check &until(ciphers__elem__dataptr >= end_of_data)
					if ( t_ciphers__elem__dataptr >= t_end_of_data )
						{
						ciphers__elem_ = 0;
						goto end_of_ciphers;
						}
					ciphers__elem_ = new uint24();
					ciphers__elem_->Parse(t_ciphers__elem__dataptr, t_end_of_data);
					// Evaluate 'let' and 'withinput' fields
					ciphers_->push_back(ciphers__elem_);
					t_ciphers__elem__dataptr += 3;
					BINPAC_ASSERT(t_ciphers__elem__dataptr <= t_end_of_data);
					ciphers__elem_ = 0;
					}
			end_of_ciphers: ;
				t_ciphers__size = t_ciphers__elem__dataptr - (t_dataptr_after_cert_data);
				// Evaluate 'let' and 'withinput' fields
				
				const_byteptr const t_dataptr_after_ciphers = t_dataptr_after_cert_data + (t_ciphers__size);
				BINPAC_ASSERT(t_dataptr_after_ciphers <= t_end_of_data);
				// Parse "conn_id_data"
				int t_conn_id_data__size;
				t_conn_id_data__size = conn_id_len();
				// Checking out-of-bound for "V2ServerHello:conn_id_data"
				if ( t_dataptr_after_ciphers + (t_conn_id_data__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ServerHello:conn_id_data",
						((t_dataptr_after_ciphers - t_begin_of_data)) + (t_conn_id_data__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = t_dataptr_after_ciphers + t_conn_id_data__size;
				int t_conn_id_data_string_length;
				t_conn_id_data_string_length = conn_id_len();
				// check for negative sizes
				if ( t_conn_id_data_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:287", t_conn_id_data_string_length);
				conn_id_data_.init(t_dataptr_after_ciphers, t_conn_id_data_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					state_changed_ =  ( session_id_hit() > 0 ? t_context->analyzer()->transition(STATE_CLIENT_HELLO_RCVD, STATE_CONN_ESTABLISHED, false) : t_context->analyzer()->transition(STATE_CLIENT_HELLO_RCVD, STATE_V2_CL_MASTER_KEY_EXPECTED, false) )  || t_context->analyzer()->lost_track();
					proc_ = t_context->analyzer()->proc_server_hello(server_version(), 0, convert_ciphers_uint24(ciphers()), session_id_hit());
					cert_ = t_context->analyzer()->proc_v2_certificate(cert_data());
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

X509Certificate::X509Certificate()
	{
	length_ = 0;
	}

X509Certificate::~X509Certificate()
	{
	delete length_;
	length_ = 0;
	certificate_.free();
	}

int X509Certificate::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "X509Certificate:length"
	if ( t_begin_of_data + (3) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("X509Certificate:length",
			(0) + (3), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "length"
	length_ = new uint24();
	length_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "certificate"
	int t_certificate__size;
	t_certificate__size = to_int()(length());
	// Checking out-of-bound for "X509Certificate:certificate"
	if ( (t_begin_of_data + 3) + (t_certificate__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("X509Certificate:certificate",
			(3) + (t_certificate__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = (t_begin_of_data + 3) + t_certificate__size;
	int t_certificate_string_length;
	t_certificate_string_length = to_int()(length());
	// check for negative sizes
	if ( t_certificate_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:305", t_certificate_string_length);
	certificate_.init((t_begin_of_data + 3), t_certificate_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	int t_X509Certificate__size;
	const_byteptr const t_dataptr_after_certificate = (t_begin_of_data + 3) + (t_certificate__size);
	BINPAC_ASSERT(t_dataptr_after_certificate <= t_end_of_data);
	t_X509Certificate__size = t_dataptr_after_certificate - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_X509Certificate__size) <= t_end_of_data);
	return t_X509Certificate__size;
	}

CertificateList::CertificateList()
	{
	val_ = 0;
	val__elem_ = 0;
	}

CertificateList::~CertificateList()
	{
	delete val__elem_;
	val__elem_ = 0;
	if ( val() )
		{
		for ( int i = 0; i < (int) val()->size(); ++i )
			{
			X509Certificate * val__elem_ = (*val_)[i];
			delete val__elem_;
			val__elem_ = 0;
			}
		}
	delete val_;
	}

int CertificateList::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	int t_val__arraylength;
	val__elem_ = 0;
	int t_val__elem__it;
	t_val__elem__it = 0;
	int t_val__size;
	val_ = new vector<X509Certificate *>;
	const_byteptr t_val__elem__dataptr = t_begin_of_data;
	for (; /* forever */; ++t_val__elem__it)
		{
		// Check &until(val__elem__dataptr >= end_of_data)
		if ( t_val__elem__dataptr >= t_end_of_data )
			{
			val__elem_ = 0;
			goto end_of_val;
			}
		val__elem_ = new X509Certificate();
		int t_val__elem__size;
		t_val__elem__size = val__elem_->Parse(t_val__elem__dataptr, t_end_of_data);
		// Evaluate 'let' and 'withinput' fields
		val_->push_back(val__elem_);
		t_val__elem__dataptr += t_val__elem__size;
		BINPAC_ASSERT(t_val__elem__dataptr <= t_end_of_data);
		val__elem_ = 0;
		}
end_of_val: ;
	t_val__size = t_val__elem__dataptr - (t_begin_of_data);
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

Certificate::Certificate()
	{
	length_ = 0;
	certificates_ = 0;
	}

Certificate::~Certificate()
	{
	delete length_;
	length_ = 0;
	delete certificates_;
	certificates_ = 0;
	}

int Certificate::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Checking out-of-bound for "Certificate:length"
	if ( t_begin_of_data + (3) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("Certificate:length",
			(0) + (3), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "length"
	length_ = new uint24();
	length_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "certificates"
	certificates_ = new CertificateList();
	int t_certificates__size;
	t_certificates__size = to_int()(length());
	// Checking out-of-bound for "Certificate:certificates"
	if ( (t_begin_of_data + 3) + (t_certificates__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("Certificate:certificates",
			(3) + (t_certificates__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = (t_begin_of_data + 3) + t_certificates__size;
	certificates_->Parse((t_begin_of_data + 3), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	}
	
	int t_Certificate__size;
	const_byteptr const t_dataptr_after_certificates = (t_begin_of_data + 3) + (t_certificates__size);
	BINPAC_ASSERT(t_dataptr_after_certificates <= t_end_of_data);
	t_Certificate__size = t_dataptr_after_certificates - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_IN_SERVER_HELLO, STATE_IN_SERVER_HELLO, false) || t_context->analyzer()->transition(STATE_SERVER_HELLO_DONE, STATE_CLIENT_CERT, true) || t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_v3_certificate(certificates());
	BINPAC_ASSERT(t_begin_of_data + (t_Certificate__size) <= t_end_of_data);
	return t_Certificate__size;
	}

ServerKeyExchange::ServerKeyExchange()
	{
	}

ServerKeyExchange::~ServerKeyExchange()
	{
	}

int ServerKeyExchange::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Parse "cont"
	int t_cont_string_length;
	t_cont_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_cont__size;
	t_cont__size = t_cont_string_length;
	// check for negative sizes
	if ( t_cont_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:329", t_cont_string_length);
	cont_.init(t_begin_of_data, t_cont_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_ServerKeyExchange__size;
	const_byteptr const t_dataptr_after_cont = t_begin_of_data + (t_cont__size);
	BINPAC_ASSERT(t_dataptr_after_cont <= t_end_of_data);
	t_ServerKeyExchange__size = t_dataptr_after_cont - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_IN_SERVER_HELLO, STATE_IN_SERVER_HELLO, false) || t_context->analyzer()->lost_track();
	BINPAC_ASSERT(t_begin_of_data + (t_ServerKeyExchange__size) <= t_end_of_data);
	return t_ServerKeyExchange__size;
	}

CertificateRequest::CertificateRequest()
	{
	}

CertificateRequest::~CertificateRequest()
	{
	}

int CertificateRequest::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Parse "cont"
	int t_cont_string_length;
	t_cont_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_cont__size;
	t_cont__size = t_cont_string_length;
	// check for negative sizes
	if ( t_cont_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:344", t_cont_string_length);
	cont_.init(t_begin_of_data, t_cont_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_CertificateRequest__size;
	const_byteptr const t_dataptr_after_cont = t_begin_of_data + (t_cont__size);
	BINPAC_ASSERT(t_dataptr_after_cont <= t_end_of_data);
	t_CertificateRequest__size = t_dataptr_after_cont - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_IN_SERVER_HELLO, STATE_IN_SERVER_HELLO, false) || t_context->analyzer()->lost_track();
	BINPAC_ASSERT(t_begin_of_data + (t_CertificateRequest__size) <= t_end_of_data);
	return t_CertificateRequest__size;
	}

ServerHelloDone::ServerHelloDone()
	{
	}

ServerHelloDone::~ServerHelloDone()
	{
	}

int ServerHelloDone::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_IN_SERVER_HELLO, STATE_SERVER_HELLO_DONE, false) || t_context->analyzer()->lost_track();
	BINPAC_ASSERT(t_begin_of_data + (0) <= t_end_of_data);
	return 0;
	}

ClientKeyExchange::ClientKeyExchange()
	{
	}

ClientKeyExchange::~ClientKeyExchange()
	{
	}

int ClientKeyExchange::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Parse "cont"
	int t_cont_string_length;
	t_cont_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_cont__size;
	t_cont__size = t_cont_string_length;
	// check for negative sizes
	if ( t_cont_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:381", t_cont_string_length);
	cont_.init(t_begin_of_data, t_cont_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_ClientKeyExchange__size;
	const_byteptr const t_dataptr_after_cont = t_begin_of_data + (t_cont__size);
	BINPAC_ASSERT(t_dataptr_after_cont <= t_end_of_data);
	t_ClientKeyExchange__size = t_dataptr_after_cont - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_SERVER_HELLO_DONE, STATE_CLIENT_KEY_NO_CERT, true) || t_context->analyzer()->transition(STATE_CLIENT_CERT, STATE_CLIENT_KEY_WITH_CERT, true) || t_context->analyzer()->lost_track();
	BINPAC_ASSERT(t_begin_of_data + (t_ClientKeyExchange__size) <= t_end_of_data);
	return t_ClientKeyExchange__size;
	}

V2ClientMasterKey::V2ClientMasterKey()
	{
	cipher_kind_ = 0;
	cl_key_len_ = 0;
	en_key_len_ = 0;
	key_arg_len_ = 0;
	buffering_state_ = 0;
	}

V2ClientMasterKey::~V2ClientMasterKey()
	{
	delete cipher_kind_;
	cipher_kind_ = 0;
	}

bool V2ClientMasterKey::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(9, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			// Checking out-of-bound for "V2ClientMasterKey:key_arg_len"
			if ( (t_begin_of_data + 7) + (2) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("V2ClientMasterKey:key_arg_len",
					(7) + (2), 
					(t_end_of_data) - (t_begin_of_data));
				}
			// Parse "cl_key_len"
			cl_key_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 3))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "en_key_len"
			en_key_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 5))));
			// Evaluate 'let' and 'withinput' fields
			// Parse "key_arg_len"
			key_arg_len_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 7))));
			// Evaluate 'let' and 'withinput' fields
			t_flow_buffer->GrowFrame(9 + cl_key_len() + en_key_len() + key_arg_len());
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Parse "cipher_kind"
				cipher_kind_ = new uint24();
				cipher_kind_->Parse(t_begin_of_data, t_end_of_data);
				// Evaluate 'let' and 'withinput' fields
				
				
				
				
				// Parse "cl_key_data"
				int t_cl_key_data__size;
				t_cl_key_data__size = cl_key_len();
				// Checking out-of-bound for "V2ClientMasterKey:cl_key_data"
				if ( (t_begin_of_data + 9) + (t_cl_key_data__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ClientMasterKey:cl_key_data",
						(9) + (t_cl_key_data__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = (t_begin_of_data + 9) + t_cl_key_data__size;
				int t_cl_key_data_string_length;
				t_cl_key_data_string_length = cl_key_len();
				// check for negative sizes
				if ( t_cl_key_data_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:400", t_cl_key_data_string_length);
				cl_key_data_.init((t_begin_of_data + 9), t_cl_key_data_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				const_byteptr const t_dataptr_after_cl_key_data = (t_begin_of_data + 9) + (t_cl_key_data__size);
				BINPAC_ASSERT(t_dataptr_after_cl_key_data <= t_end_of_data);
				// Parse "en_key_data"
				int t_en_key_data__size;
				t_en_key_data__size = en_key_len();
				// Checking out-of-bound for "V2ClientMasterKey:en_key_data"
				if ( t_dataptr_after_cl_key_data + (t_en_key_data__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ClientMasterKey:en_key_data",
						((t_dataptr_after_cl_key_data - t_begin_of_data)) + (t_en_key_data__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = t_dataptr_after_cl_key_data + t_en_key_data__size;
				int t_en_key_data_string_length;
				t_en_key_data_string_length = en_key_len();
				// check for negative sizes
				if ( t_en_key_data_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:401", t_en_key_data_string_length);
				en_key_data_.init(t_dataptr_after_cl_key_data, t_en_key_data_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				const_byteptr const t_dataptr_after_en_key_data = t_dataptr_after_cl_key_data + (t_en_key_data__size);
				BINPAC_ASSERT(t_dataptr_after_en_key_data <= t_end_of_data);
				// Parse "key_arg_data"
				int t_key_arg_data__size;
				t_key_arg_data__size = key_arg_len();
				// Checking out-of-bound for "V2ClientMasterKey:key_arg_data"
				if ( t_dataptr_after_en_key_data + (t_key_arg_data__size) > t_end_of_data )
					{
					// Handle out-of-bound condition
					throw ExceptionOutOfBound("V2ClientMasterKey:key_arg_data",
						((t_dataptr_after_en_key_data - t_begin_of_data)) + (t_key_arg_data__size), 
						(t_end_of_data) - (t_begin_of_data));
					}
				{
				// Setting t_end_of_data with &length
				const_byteptr t_end_of_data = t_dataptr_after_en_key_data + t_key_arg_data__size;
				int t_key_arg_data_string_length;
				t_key_arg_data_string_length = key_arg_len();
				// check for negative sizes
				if ( t_key_arg_data_string_length < 0 )
				throw ExceptionInvalidStringLength("./ssl-protocol.pac:402", t_key_arg_data_string_length);
				key_arg_data_.init(t_dataptr_after_en_key_data, t_key_arg_data_string_length);
				// Evaluate 'let' and 'withinput' fields
				}
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					state_changed_ = t_context->analyzer()->transition(STATE_V2_CL_MASTER_KEY_EXPECTED, STATE_CONN_ESTABLISHED, true) || t_context->analyzer()->lost_track();
					proc_ = t_context->analyzer()->proc_v2_client_master_key(to_int()(cipher_kind()));
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

CertificateVerify::CertificateVerify()
	{
	}

CertificateVerify::~CertificateVerify()
	{
	}

int CertificateVerify::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Parse "cont"
	int t_cont_string_length;
	t_cont_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_cont__size;
	t_cont__size = t_cont_string_length;
	// check for negative sizes
	if ( t_cont_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:417", t_cont_string_length);
	cont_.init(t_begin_of_data, t_cont_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_CertificateVerify__size;
	const_byteptr const t_dataptr_after_cont = t_begin_of_data + (t_cont__size);
	BINPAC_ASSERT(t_dataptr_after_cont <= t_end_of_data);
	t_CertificateVerify__size = t_dataptr_after_cont - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->transition(STATE_CLIENT_KEY_WITH_CERT, STATE_CLIENT_CERT_VERIFIED, true) || t_context->analyzer()->lost_track();
	BINPAC_ASSERT(t_begin_of_data + (t_CertificateVerify__size) <= t_end_of_data);
	return t_CertificateVerify__size;
	}

UnknownHandshake::UnknownHandshake(uint8 msg_type)
	{
	msg_type_ = msg_type;
	}

UnknownHandshake::~UnknownHandshake()
	{
	}

int UnknownHandshake::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Parse "cont"
	int t_cont_string_length;
	t_cont_string_length = (t_end_of_data) - (t_begin_of_data);
	int t_cont__size;
	t_cont__size = t_cont_string_length;
	// check for negative sizes
	if ( t_cont_string_length < 0 )
	throw ExceptionInvalidStringLength("./ssl-protocol.pac:439", t_cont_string_length);
	cont_.init(t_begin_of_data, t_cont_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_UnknownHandshake__size;
	const_byteptr const t_dataptr_after_cont = t_begin_of_data + (t_cont__size);
	BINPAC_ASSERT(t_dataptr_after_cont <= t_end_of_data);
	t_UnknownHandshake__size = t_dataptr_after_cont - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	state_changed_ = t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_unknown_handshake(msg_type());
	BINPAC_ASSERT(t_begin_of_data + (t_UnknownHandshake__size) <= t_end_of_data);
	return t_UnknownHandshake__size;
	}

Handshake::Handshake()
	{
	msg_type_ = 0;
	length_ = 0;
	body_case_index_ = -1;
	hello_request_ = 0;
	client_hello_ = 0;
	server_hello_ = 0;
	certificate_ = 0;
	server_key_exchange_ = 0;
	certificate_request_ = 0;
	server_hello_done_ = 0;
	certificate_verify_ = 0;
	client_key_exchange_ = 0;
	unknown_handshake_ = 0;
	buffering_state_ = 0;
	}

Handshake::~Handshake()
	{
	delete length_;
	length_ = 0;
	switch ( body_case_index() )
		{
		case 0:
			// Clean up "hello_request"
			{
			delete hello_request_;
			hello_request_ = 0;
			}
			break;
		case 1:
			// Clean up "client_hello"
			{
			delete client_hello_;
			client_hello_ = 0;
			}
			break;
		case 2:
			// Clean up "server_hello"
			{
			delete server_hello_;
			server_hello_ = 0;
			}
			break;
		case 11:
			// Clean up "certificate"
			{
			delete certificate_;
			certificate_ = 0;
			}
			break;
		case 12:
			// Clean up "server_key_exchange"
			{
			delete server_key_exchange_;
			server_key_exchange_ = 0;
			}
			break;
		case 13:
			// Clean up "certificate_request"
			{
			delete certificate_request_;
			certificate_request_ = 0;
			}
			break;
		case 14:
			// Clean up "server_hello_done"
			{
			delete server_hello_done_;
			server_hello_done_ = 0;
			}
			break;
		case 15:
			// Clean up "certificate_verify"
			{
			delete certificate_verify_;
			certificate_verify_ = 0;
			}
			break;
		case 16:
			// Clean up "client_key_exchange"
			{
			delete client_key_exchange_;
			client_key_exchange_ = 0;
			}
			break;
		default:
			// Clean up "unknown_handshake"
			{
			delete unknown_handshake_;
			unknown_handshake_ = 0;
			}
			break;
		}
	}

bool Handshake::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	const_byteptr t_begin_of_data = t_flow_buffer->begin();
	const_byteptr t_end_of_data = t_flow_buffer->end();
	switch ( buffering_state_ )
		{
		case 0:
			if ( buffering_state_ == 0 )
				{
				t_flow_buffer->NewFrame(4, false);
				buffering_state_ = 1;
				}
			buffering_state_ = 1;
			break;
		case 1:
			{
			buffering_state_ = 2;
			// Checking out-of-bound for "Handshake:length"
			if ( (t_begin_of_data + 1) + (3) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("Handshake:length",
					(1) + (3), 
					(t_end_of_data) - (t_begin_of_data));
				}
			// Parse "length"
			length_ = new uint24();
			length_->Parse((t_begin_of_data + 1), t_end_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_flow_buffer->GrowFrame(4 + to_int()(length()));
			}
			break;
		case 2:
			BINPAC_ASSERT(t_flow_buffer->ready());
			if ( t_flow_buffer->ready() )
				{
				// Parse "msg_type"
				msg_type_ = *((uint8 const *) (t_begin_of_data));
				// Evaluate 'let' and 'withinput' fields
				
				
				// Parse "body"
				int t_body__size;
				body_case_index_ = msg_type();
				switch ( body_case_index() )
					{
					case 0:
						// Parse "hello_request"
						{
						hello_request_ = new HelloRequest();
						hello_request_->Parse(0, 0, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = 0;
						}
						break;
					case 1:
						// Parse "client_hello"
						{
						client_hello_ = new ClientHello();
						int t_client_hello__size;
						t_client_hello__size = client_hello_->Parse((t_begin_of_data + 4), t_end_of_data, t_context, t_byteorder);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_client_hello__size;
						}
						break;
					case 2:
						// Parse "server_hello"
						{
						server_hello_ = new ServerHello();
						int t_server_hello__size;
						t_server_hello__size = server_hello_->Parse((t_begin_of_data + 4), t_end_of_data, t_context, t_byteorder);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_server_hello__size;
						}
						break;
					case 11:
						// Parse "certificate"
						{
						certificate_ = new Certificate();
						int t_certificate__size;
						t_certificate__size = certificate_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_certificate__size;
						}
						break;
					case 12:
						// Parse "server_key_exchange"
						{
						server_key_exchange_ = new ServerKeyExchange();
						int t_server_key_exchange__size;
						t_server_key_exchange__size = server_key_exchange_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_server_key_exchange__size;
						}
						break;
					case 13:
						// Parse "certificate_request"
						{
						certificate_request_ = new CertificateRequest();
						int t_certificate_request__size;
						t_certificate_request__size = certificate_request_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_certificate_request__size;
						}
						break;
					case 14:
						// Parse "server_hello_done"
						{
						server_hello_done_ = new ServerHelloDone();
						server_hello_done_->Parse(0, 0, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = 0;
						}
						break;
					case 15:
						// Parse "certificate_verify"
						{
						certificate_verify_ = new CertificateVerify();
						int t_certificate_verify__size;
						t_certificate_verify__size = certificate_verify_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_certificate_verify__size;
						}
						break;
					case 16:
						// Parse "client_key_exchange"
						{
						client_key_exchange_ = new ClientKeyExchange();
						int t_client_key_exchange__size;
						t_client_key_exchange__size = client_key_exchange_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_client_key_exchange__size;
						}
						break;
					default:
						// Parse "unknown_handshake"
						{
						unknown_handshake_ = new UnknownHandshake(msg_type());
						int t_unknown_handshake__size;
						t_unknown_handshake__size = unknown_handshake_->Parse((t_begin_of_data + 4), t_end_of_data, t_context);
						// Evaluate 'let' and 'withinput' fields
						t_body__size = t_unknown_handshake__size;
						}
						break;
					}
				// Evaluate 'let' and 'withinput' fields
				
				t_val_parsing_complete = true;
				if ( t_val_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					proc_ = t_context->analyzer()->proc_handshake(this);
					}
				BINPAC_ASSERT(t_val_parsing_complete);
				buffering_state_ = 0;
				}
			break;
		default:
			BINPAC_ASSERT(buffering_state_ <= 2);
			break;
		}
	return t_val_parsing_complete;
	}

UnknownRecord::UnknownRecord()
	{
	}

UnknownRecord::~UnknownRecord()
	{
	}

int UnknownRecord::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Checking out-of-bound for "UnknownRecord"
	if ( t_begin_of_data + (0) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("UnknownRecord",
			(0) + (0), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "cont"
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	discard_ = t_context->flow()->discard_data();
	state_changed_ = t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_unknown_record(this);
	BINPAC_ASSERT(t_begin_of_data + (0) <= t_end_of_data);
	return 0;
	}

PlaintextRecord::PlaintextRecord()
	{
	val_case_index_ = -1;
	ch_cipher_ = 0;
	alert_ = 0;
	handshakes_ = 0;
	app_data_ = 0;
	v2_error_ = 0;
	v2_client_hello_ = 0;
	v2_client_master_key_ = 0;
	v2_server_hello_ = 0;
	unknown_record_ = 0;
	}

PlaintextRecord::~PlaintextRecord()
	{
	switch ( val_case_index() )
		{
		case 20:
			// Clean up "ch_cipher"
			{
			delete ch_cipher_;
			ch_cipher_ = 0;
			}
			break;
		case 21:
			// Clean up "alert"
			{
			delete alert_;
			alert_ = 0;
			}
			break;
		case 22:
			// Clean up "handshakes"
			{
			delete handshakes_;
			handshakes_ = 0;
			}
			break;
		case 23:
			// Clean up "app_data"
			{
			delete app_data_;
			app_data_ = 0;
			}
			break;
		case 300:
			// Clean up "v2_error"
			{
			delete v2_error_;
			v2_error_ = 0;
			}
			break;
		case 301:
			// Clean up "v2_client_hello"
			{
			delete v2_client_hello_;
			v2_client_hello_ = 0;
			}
			break;
		case 302:
			// Clean up "v2_client_master_key"
			{
			delete v2_client_master_key_;
			v2_client_master_key_ = 0;
			}
			break;
		case 304:
			// Clean up "v2_server_hello"
			{
			delete v2_server_hello_;
			v2_server_hello_ = 0;
			}
			break;
		case 400:
			// Clean up "unknown_record"
			{
			delete unknown_record_;
			unknown_record_ = 0;
			}
			break;
		}
	}

bool PlaintextRecord::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context, int t_byteorder)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	val_case_index_ = t_context->analyzer()->current_record_type();
	switch ( val_case_index() )
		{
		case 20:
			// Parse "ch_cipher"
			{
			if ( ! ch_cipher_ )
				{
				ch_cipher_ = new ChangeCipherSpec();
				}
			bool t_ch_cipher_parsing_complete;
			t_ch_cipher_parsing_complete = false;
			while ( ! t_ch_cipher_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_ch_cipher_parsing_complete = ch_cipher_->ParseBuffer(t_flow_buffer, t_context);
				if ( t_ch_cipher_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_ch_cipher_parsing_complete;
			}
			break;
		case 21:
			// Parse "alert"
			{
			if ( ! alert_ )
				{
				alert_ = new Alert();
				}
			bool t_alert_parsing_complete;
			t_alert_parsing_complete = false;
			while ( ! t_alert_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_alert_parsing_complete = alert_->ParseBuffer(t_flow_buffer, t_context);
				if ( t_alert_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_alert_parsing_complete;
			}
			break;
		case 22:
			// Parse "handshakes"
			{
			if ( ! handshakes_ )
				{
				handshakes_ = new Handshake();
				}
			bool t_handshakes_parsing_complete;
			t_handshakes_parsing_complete = false;
			while ( ! t_handshakes_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_handshakes_parsing_complete = handshakes_->ParseBuffer(t_flow_buffer, t_context, t_byteorder);
				if ( t_handshakes_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_handshakes_parsing_complete;
			}
			break;
		case 23:
			// Parse "app_data"
			{
			if ( ! app_data_ )
				{
				app_data_ = new ApplicationData();
				}
			bool t_app_data_parsing_complete;
			t_app_data_parsing_complete = false;
			t_app_data_parsing_complete = true;
			t_val_parsing_complete = t_app_data_parsing_complete;
			}
			break;
		case 300:
			// Parse "v2_error"
			{
			if ( ! v2_error_ )
				{
				v2_error_ = new V2Error();
				}
			bool t_v2_error_parsing_complete;
			t_v2_error_parsing_complete = false;
			while ( ! t_v2_error_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_v2_error_parsing_complete = v2_error_->ParseBuffer(t_flow_buffer, t_context, t_byteorder);
				if ( t_v2_error_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_v2_error_parsing_complete;
			}
			break;
		case 301:
			// Parse "v2_client_hello"
			{
			if ( ! v2_client_hello_ )
				{
				v2_client_hello_ = new V2ClientHello();
				}
			bool t_v2_client_hello_parsing_complete;
			t_v2_client_hello_parsing_complete = false;
			while ( ! t_v2_client_hello_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_v2_client_hello_parsing_complete = v2_client_hello_->ParseBuffer(t_flow_buffer, t_context, t_byteorder);
				if ( t_v2_client_hello_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_v2_client_hello_parsing_complete;
			}
			break;
		case 302:
			// Parse "v2_client_master_key"
			{
			if ( ! v2_client_master_key_ )
				{
				v2_client_master_key_ = new V2ClientMasterKey();
				}
			bool t_v2_client_master_key_parsing_complete;
			t_v2_client_master_key_parsing_complete = false;
			while ( ! t_v2_client_master_key_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_v2_client_master_key_parsing_complete = v2_client_master_key_->ParseBuffer(t_flow_buffer, t_context, t_byteorder);
				if ( t_v2_client_master_key_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_v2_client_master_key_parsing_complete;
			}
			break;
		case 304:
			// Parse "v2_server_hello"
			{
			if ( ! v2_server_hello_ )
				{
				v2_server_hello_ = new V2ServerHello();
				}
			bool t_v2_server_hello_parsing_complete;
			t_v2_server_hello_parsing_complete = false;
			while ( ! t_v2_server_hello_parsing_complete && t_flow_buffer->ready() )
				{
				const_byteptr t_begin_of_data = t_flow_buffer->begin();
				const_byteptr t_end_of_data = t_flow_buffer->end();
				t_v2_server_hello_parsing_complete = v2_server_hello_->ParseBuffer(t_flow_buffer, t_context, t_byteorder);
				if ( t_v2_server_hello_parsing_complete )
					{
					// Evaluate 'let' and 'withinput' fields
					}
				}
			t_val_parsing_complete = t_v2_server_hello_parsing_complete;
			}
			break;
		case 400:
			// Parse "unknown_record"
			{
			if ( ! unknown_record_ )
				{
				unknown_record_ = new UnknownRecord();
				}
			bool t_unknown_record_parsing_complete;
			t_unknown_record_parsing_complete = false;
			t_unknown_record_parsing_complete = true;
			t_val_parsing_complete = t_unknown_record_parsing_complete;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("PlaintextRecord", val_case_index());
			break;
		}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		}
	return t_val_parsing_complete;
	}

CiphertextRecord::CiphertextRecord()
	{
	}

CiphertextRecord::~CiphertextRecord()
	{
	}

int CiphertextRecord::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSSL * t_context)
	{
	// Evaluate 'let' and 'withinput' fields
	discard_ = t_context->flow()->discard_data();
	state_changed_ = t_context->analyzer()->transition(STATE_ABBREV_SERVER_ENCRYPTED, STATE_ABBREV_SERVER_FINISHED, false) || t_context->analyzer()->transition(STATE_CLIENT_ENCRYPTED, STATE_CLIENT_FINISHED, true) || t_context->analyzer()->transition(STATE_COMM_ENCRYPTED, STATE_CONN_ESTABLISHED, false) || t_context->analyzer()->transition(STATE_COMM_ENCRYPTED, STATE_CONN_ESTABLISHED, true) || t_context->analyzer()->transition(STATE_CONN_ESTABLISHED, STATE_CONN_ESTABLISHED, false) || t_context->analyzer()->transition(STATE_CONN_ESTABLISHED, STATE_CONN_ESTABLISHED, true) || t_context->analyzer()->lost_track();
	proc_ = t_context->analyzer()->proc_ciphertext_record(this);
	BINPAC_ASSERT(t_begin_of_data + (0) <= t_end_of_data);
	return 0;
	}

SSLPDU::SSLPDU()
	{
	val_case_index_ = -1;
	ciphertext_ = 0;
	plaintext_ = 0;
	byteorder_ = bigendian;
	}

SSLPDU::~SSLPDU()
	{
	switch ( val_case_index() )
		{
		case 10:
		case 8:
		case 12:
		case 13:
			// Clean up "ciphertext"
			{
			delete ciphertext_;
			ciphertext_ = 0;
			}
			break;
		default:
			// Clean up "plaintext"
			{
			delete plaintext_;
			plaintext_ = 0;
			}
			break;
		}
	}

bool SSLPDU::ParseBuffer(flow_buffer_t t_flow_buffer, ContextSSL * t_context)
	{
	bool t_val_parsing_complete;
	t_val_parsing_complete = false;
	val_case_index_ = t_context->analyzer()->state();
	switch ( val_case_index() )
		{
		case 10:
		case 8:
		case 12:
		case 13:
			// Parse "ciphertext"
			{
			if ( ! ciphertext_ )
				{
				ciphertext_ = new CiphertextRecord();
				}
			bool t_ciphertext_parsing_complete;
			t_ciphertext_parsing_complete = false;
			t_ciphertext_parsing_complete = true;
			t_val_parsing_complete = t_ciphertext_parsing_complete;
			}
			break;
		default:
			// Parse "plaintext"
			{
			if ( ! plaintext_ )
				{
				plaintext_ = new PlaintextRecord();
				}
			bool t_plaintext_parsing_complete;
			t_plaintext_parsing_complete = false;
			t_plaintext_parsing_complete = plaintext_->ParseBuffer(t_flow_buffer, t_context, byteorder());
			if ( t_plaintext_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			t_val_parsing_complete = t_plaintext_parsing_complete;
			}
			break;
		}
	if ( t_val_parsing_complete )
		{
		// Evaluate 'let' and 'withinput' fields
		consumed_ = t_context->flow()->consume_data();
		}
	return t_val_parsing_complete;
	}

SSLAnalyzer::SSLAnalyzer()
	{
	upflow_ = new SSLFlow(this, true);
	downflow_ = new SSLFlow(this, false);

		current_record_type_ = -1;
		current_record_version_ = -1;
		current_record_length_ = -1;
		current_record_is_orig_ = false;
		state_ = STATE_INITIAL;
		old_state_ = STATE_INITIAL;
		hello_requested_ = false;
	

		bro_analyzer_ = 0;

		client_session_id_ = 0;
		advertised_ciphers_ = new vector<int>;
		version_ = -1;
		cipher_ = -1;

#ifdef USE_OPENSSL
		if ( ! X509_Cert::bInited )
			X509_Cert::init();
#endif
	
	}

SSLAnalyzer::~SSLAnalyzer()
	{

		delete client_session_id_;
		client_session_id_ = 0;

		delete advertised_ciphers_;
		advertised_ciphers_ = 0;
	
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void SSLAnalyzer::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void SSLAnalyzer::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void SSLAnalyzer::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();

		if ( state_ != STATE_CONN_ESTABLISHED &&
		     state_ != STATE_TRACK_LOST && state_ != STATE_INITIAL )
			bro_analyzer()->ProtocolViolation(fmt("unexpected end of connection in state %s",
				state_label(state_).c_str()));
	
	}

int SSLAnalyzer::current_record_type()
	{
 return current_record_type_; 
	}

int SSLAnalyzer::current_record_version()
	{
 return current_record_version_; 
	}

int SSLAnalyzer::current_record_length()
	{
 return current_record_length_; 
	}

bool SSLAnalyzer::current_record_is_orig()
	{
 return current_record_is_orig_; 
	}

bool SSLAnalyzer::next_record(const_bytestring const & rec, int type, int version, bool is_orig)
	{

		current_record_type_ = type;
		current_record_version_ = version;
		current_record_length_ = rec.length();
		current_record_is_orig_ = is_orig;

		NewData(is_orig, rec.begin(), rec.end());

		return true;
		
	}

int SSLAnalyzer::state()
	{
 return state_; 
	}

int SSLAnalyzer::old_state()
	{
 return old_state_; 
	}

bool SSLAnalyzer::transition(AnalyzerState olds, AnalyzerState news, bool is_orig)
	{

		if ( (olds != STATE_ANY && olds != state_) ||
		     current_record_is_orig_ != is_orig )
			return false;

		old_state_ = state_;
		state_ = news;

		return true;
		
	}

bool SSLAnalyzer::lost_track()
	{

		state_ = STATE_TRACK_LOST;
		return false;
		
	}

bool SSLAnalyzer::hello_requested()
	{

		bool ret = hello_requested_;
		hello_requested_ = false;
		return ret;
		
	}

bool SSLAnalyzer::set_hello_requested(bool val)
	{

		hello_requested_ = val;
		return val;
		
	}

Analyzer * SSLAnalyzer::bro_analyzer()
	{

		return bro_analyzer_;
		
	}

void SSLAnalyzer::set_bro_analyzer(Analyzer * a)
	{

		bro_analyzer_ = a;
		
	}

bool SSLAnalyzer::check_cipher(int cipher)
	{

		if ( ! ssl_compare_cipherspecs )
			return true;

		if ( std::find(advertised_ciphers_->begin(),
				advertised_ciphers_->end(), cipher) ==
		     advertised_ciphers_->end() )
			{
			bro_analyzer()->ProtocolViolation("chosen cipher not advertised before");
			return false;
			}

		return true;
		
	}

void SSLAnalyzer::certificate_error(int err_num)
	{

#ifdef USE_OPENSSL
		StringVal* err_str =
			new StringVal(X509_verify_cert_error_string(err_num));
		bro_event_ssl_X509_error(bro_analyzer_, bro_analyzer_->Conn(),
						err_num, err_str);
#endif
		
	}

bool SSLAnalyzer::proc_change_cipher_spec(ChangeCipherSpec * msg)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected ChangeCipherSpec from %s at state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));
		return true;
		
	}

bool SSLAnalyzer::proc_application_data(ApplicationData * msg)
	{

		if ( state_ != STATE_CONN_ESTABLISHED )
			bro_analyzer()->ProtocolViolation(fmt("unexpected ApplicationData from %s at state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));
		return true;
		
	}

bool SSLAnalyzer::proc_alert(int level, int description)
	{

		bro_event_ssl_conn_alert(bro_analyzer_, bro_analyzer_->Conn(),
						current_record_version_, level,
						description);
		return true;
		
	}

bool SSLAnalyzer::proc_client_hello(uint16 version, vector<uint8> * session_id, vector<int> * csuits)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected client hello message from %s in state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));

		if ( ! version_ok(version) )
			bro_analyzer()->ProtocolViolation(fmt("unsupported client SSL version 0x%04x", version));

		delete client_session_id_;
		client_session_id_ = new vector<uint8>(*session_id);

		TableVal* cipher_table = new TableVal(cipher_suites_list);
		for ( unsigned int i = 0; i < csuits->size(); ++i )
			{
			Val* ciph = new Val((*csuits)[i], TYPE_COUNT);
			cipher_table->Assign(ciph, 0);
			Unref(ciph);
			}

		bro_event_ssl_conn_attempt(bro_analyzer_, bro_analyzer_->Conn(),
						version, cipher_table);

		if ( ssl_compare_cipherspecs )
			{
			delete advertised_ciphers_;
			advertised_ciphers_ = csuits;
			}
		else
			delete csuits;

		return true;
		
	}

bool SSLAnalyzer::proc_server_hello(uint16 version, vector<uint8> * session_id, vector<int> * ciphers, int v2_sess_hit)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected server hello message from %s in state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));

		if ( ! version_ok(version) )
			bro_analyzer()->ProtocolViolation(fmt("unsupported server SSL version 0x%04x", version));

		version_ = version;

		TableVal* chosen_ciphers = new TableVal(cipher_suites_list);
		for ( unsigned int i = 0; i < ciphers->size(); ++i )
			{
			Val* ciph = new Val((*ciphers)[i], TYPE_COUNT);
			chosen_ciphers->Assign(ciph, 0);
			Unref(ciph);
			}

		bro_event_ssl_conn_server_reply(bro_analyzer_,
						bro_analyzer_->Conn(),
						version_, chosen_ciphers);

		if ( v2_sess_hit < 0 )
			{ // this is SSLv3
			cipher_ = (*ciphers)[0];
			check_cipher(cipher_);
			TableVal* tv = to_table_val(session_id);
			if ( client_session_id_ &&
			     *client_session_id_ == *session_id )
				bro_event_ssl_conn_reused(bro_analyzer_,
						bro_analyzer_->Conn(), tv);
			else
				bro_event_ssl_session_insertion(bro_analyzer_,
						bro_analyzer_->Conn(), tv);

			delete ciphers;
			}

		else if ( v2_sess_hit > 0 )
			{ // this is SSLv2 and a session hit
			if ( client_session_id_ )
				{
				TableVal* tv = to_table_val(client_session_id_);
				bro_event_ssl_conn_reused(bro_analyzer_,
						bro_analyzer_->Conn(), tv);
				}

			// We don't know the chosen cipher, as there is
			// no session storage.
			bro_event_ssl_conn_established(bro_analyzer_,
							bro_analyzer_->Conn(),
							version_, 0xffffffff);
			delete ciphers;
			}

		else
			{
			// This is SSLv2; we have to set advertised
			// ciphers to server ciphers.
			if ( ssl_compare_cipherspecs )
				{
				delete advertised_ciphers_;
				advertised_ciphers_ = ciphers;
				}
			}

		bro_analyzer()->ProtocolConfirmation();
		return true;
		
	}

bool SSLAnalyzer::proc_certificate(vector<bytestring> * certificates)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected certificate message from %s in state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));

		if ( ! ssl_analyze_certificates )
			return true;
		if ( certificates->size() == 0 )
			return true;

		bro_event_ssl_certificate_seen(bro_analyzer_,
						bro_analyzer_->Conn(),
						! current_record_is_orig_);

#ifdef USE_OPENSSL
		const bytestring& cert = (*certificates)[0];
		const uint8* data = cert.data();

		X509* pCert = d2i_X509_binpac(NULL, &data, cert.length());
		if ( ! pCert )
			{
			// X509_V_UNABLE_TO_DECRYPT_CERT_SIGNATURE
			certificate_error(4);
			return false;
			}

		RecordVal* pX509Cert = new RecordVal(x509_type);

		char tmp[256];
		X509_NAME_oneline(X509_get_issuer_name(pCert), tmp, sizeof tmp);
		pX509Cert->Assign(0, new StringVal(tmp));
		X509_NAME_oneline(X509_get_subject_name(pCert), tmp, sizeof tmp);

		pX509Cert->Assign(1, new StringVal(tmp));
		pX509Cert->Assign(2, new AddrVal(bro_analyzer_->Conn()->OrigAddr()));

		bro_event_ssl_certificate(bro_analyzer_, bro_analyzer_->Conn(),
					pX509Cert, current_record_is_orig_);

		if ( X509_get_ext_count(pCert) > 0 )
			{
			TableVal* x509ex = new TableVal(x509_extension);

			for ( int k = 0; k < X509_get_ext_count(pCert); ++k )
				{
				X509_EXTENSION* ex = X509_get_ext(pCert, k);
				ASN1_OBJECT* obj = X509_EXTENSION_get_object(ex);

				char buf[256];
				i2t_ASN1_OBJECT(buf, sizeof(buf), obj);
				Val* index = new Val(k+1, TYPE_COUNT);
				Val* value = new StringVal(strlen(buf), buf);
				x509ex->Assign(index, value);
				Unref(index);
				}

			bro_event_process_X509_extensions(bro_analyzer_,
						bro_analyzer_->Conn(), x509ex);
			}

		if ( ssl_verify_certificates )
			{
			STACK_OF(X509)* untrusted_certs = 0;
			if ( certificates->size() > 1 )
				{
				untrusted_certs = sk_X509_new_null();
				if ( ! untrusted_certs )
					{
					// X509_V_ERR_OUT_OF_MEM;
					certificate_error(17);
					return false;
					}

				for ( unsigned int i = 1;
				      i < certificates->size(); ++i )
					{
					const bytestring& temp =
						(*certificates)[i];
					const uint8* tdata = temp.data();
					X509* pTemp = d2i_X509_binpac(NULL,
							&tdata, temp.length());
					if ( ! pTemp )
						{
						// X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT
						certificate_error(2);
						return false;
						}

					sk_X509_push(untrusted_certs, pTemp);
					}
				}

			X509_STORE_CTX csc;
			X509_STORE_CTX_init(&csc, X509_Cert::ctx,
						pCert, untrusted_certs);
			X509_STORE_CTX_set_time(&csc, 0, time_t(network_time()));
			if (! X509_verify_cert(&csc))
				certificate_error(csc.error);
			X509_STORE_CTX_cleanup(&csc);

			sk_X509_pop_free(untrusted_certs, X509_free);
			}

		X509_free(pCert);
#endif
	return true;
		
	}

bool SSLAnalyzer::proc_v2_certificate(bytestring const & cert)
	{

		vector<bytestring>* cert_list = new vector<bytestring>(1,cert);
		bool ret = proc_certificate(cert_list);
		delete cert_list;
		return ret;
		
	}

bool SSLAnalyzer::proc_v3_certificate(CertificateList * cl)
	{

		vector<X509Certificate*>* certs = cl->val();
		vector<bytestring>* cert_list = new vector<bytestring>();

		std::transform(certs->begin(), certs->end(),
		std::back_inserter(*cert_list), extract_certs());

		bool ret = proc_certificate(cert_list);
		delete cert_list;

		return ret;
		
	}

bool SSLAnalyzer::proc_v2_client_master_key(int cipher)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected v2 client master key message from %s in state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));

		check_cipher(cipher);
		bro_event_ssl_conn_established(bro_analyzer_,
				bro_analyzer_->Conn(), version_, cipher);

		return true;
		
	}

bool SSLAnalyzer::proc_unknown_handshake(int msg_type)
	{

		bro_analyzer()->ProtocolViolation(fmt("unknown handshake message (%d) from %s",
			msg_type, orig_label(current_record_is_orig_).c_str()));
		return true;
		
	}

bool SSLAnalyzer::proc_handshake(Handshake * msg)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected Handshake message %s from %s in state %s",
				handshake_type_label(msg->msg_type()).c_str(),
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));
		return true;
		
	}

bool SSLAnalyzer::proc_unknown_record(UnknownRecord * msg)
	{

		bro_analyzer()->ProtocolViolation(fmt("unknown SSL record type (%d) from %s",
				current_record_type_,
				orig_label(current_record_is_orig_).c_str()));
		return true;
		
	}

bool SSLAnalyzer::proc_ciphertext_record(CiphertextRecord * msg)
	{

		if ( state_ == STATE_TRACK_LOST )
			bro_analyzer()->ProtocolViolation(fmt("unexpected ciphertext record from %s in state %s",
				orig_label(current_record_is_orig_).c_str(),
				state_label(old_state_).c_str()));

		if ( state_ == STATE_CONN_ESTABLISHED &&
		     old_state_ == STATE_COMM_ENCRYPTED )
			{
			bro_event_ssl_conn_established(bro_analyzer_,
							bro_analyzer_->Conn(),
							version_, cipher_);
			}

		return true;
		
	}

SSLFlow::SSLFlow(SSLAnalyzer * connection, bool is_orig)
	{
	flow_buffer_ = 0;
	connection_ = connection;
	is_orig_ = is_orig;
	dataunit_ = 0;
	context_ = 0;
	flow_buffer_ = new FlowBuffer();
	}

SSLFlow::~SSLFlow()
	{
	delete dataunit_;
	dataunit_ = 0;
	delete context_;
	context_ = 0;
	delete flow_buffer_;
	flow_buffer_ = 0;
	}

void SSLFlow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		flow_buffer_->NewData(t_begin_of_data, t_end_of_data);
		while ( flow_buffer_->data_available() && 
			( !flow_buffer_->have_pending_request() || flow_buffer_->ready() ) )
			{
			if ( ! dataunit_ )
				{
				BINPAC_ASSERT(!context_);
				dataunit_ = new SSLPDU();
				context_ = new ContextSSL(connection(), this, flow_buffer_);
				}
			bool t_dataunit_parsing_complete;
			t_dataunit_parsing_complete = false;
			t_dataunit_parsing_complete = dataunit_->ParseBuffer(flow_buffer_, context_);
			if ( t_dataunit_parsing_complete )
				{
				// Evaluate 'let' and 'withinput' fields
				}
			if ( t_dataunit_parsing_complete )
				{
				// Clean up the flow unit after parsing
				delete dataunit_;
				dataunit_ = 0;
				delete context_;
				context_ = 0;
				}
			else
				{
				// Resume upon next input segment
				BINPAC_ASSERT(!flow_buffer_->ready());
				break;
				}
			}
		}
	catch ( Exception const &e )
		{
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		flow_buffer_->DiscardData();
		throw e;
		}
	}

void SSLFlow::NewGap(int gap_length)
	{
	flow_buffer_->NewGap(gap_length);
	}
void SSLFlow::FlowEOF()
	{
	flow_buffer_->set_eof();
	NewData(0, 0);
	}
bool SSLFlow::discard_data()
	{

		flow_buffer_->DiscardData();
		return true;
		
	}

bool SSLFlow::data_available()
	{

		return flow_buffer_->data_available();
		
	}

bool SSLFlow::consume_data()
	{

		flow_buffer_->NewFrame(0, false);
		return true;
		
	}


#ifdef USE_OPENSSL
	void free_X509(void* cert)
		{
		X509_free((X509*) cert);
		}

	X509* d2i_X509_binpac(X509** px, const uint8** in, int len)
		{
#ifdef OPENSSL_D2I_X509_USES_CONST_CHAR
		return d2i_X509(px, in, len);
#else
		return d2i_X509(px, (u_char**) in, len);
#endif
		}

#endif

TableVal * to_table_val(vector<uint8> * data)
	{

	TableVal* tv = new TableVal(SSL_sessionID);
	for ( unsigned int i = 0; i < data->size(); i += 4 )
		{
		uint32 temp = 0;
		for ( unsigned int j = 0; j < 4; ++j )
		if ( i + j < data->size() )
			temp |= (*data)[i + j] << (24 - 8 * j);

		Val* idx = new Val(i / 4, TYPE_COUNT);
		tv->Assign(idx, new Val((*data)[i], TYPE_COUNT));
		Unref(idx);
		}

	return tv;
	
	}

bool version_ok(uint16 vers)
	{

	switch ( vers ) {
	case SSLv20:
	case SSLv30:
	case TLSv10:
	case TLSv11:
		return true;

	default:
		return false;
	}
	
	}

vector<int> * convert_ciphers_uint24(vector<uint24 *> * ciph)
	{

	vector<int>* newciph = new vector<int>();

	std::transform(ciph->begin(), ciph->end(),
	std::back_inserter(*newciph), to_int());

	return newciph;
	
	}

vector<int> * convert_ciphers_uint16(vector<uint16> * ciph)
	{

	vector<int>* newciph = new vector<int>();

	std::copy(ciph->begin(), ciph->end(),
	std::back_inserter(*newciph));

	return newciph;
	
	}

} // namespace SSL
}  // namespace binpac
